USE [WaspTrackInventory]
GO


print '----------------------------'
print '--                          '
print '--  DROP PROC SECTION       '
print '--                          '
print '----------------------------'


if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpActivityReport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpActivityReport]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpArchiveInventoryTransactions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpArchiveInventoryTransactions]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpAuditResults]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpAuditResults]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpBackOrderTracking]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpBackOrderTracking]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCleanDatabaseToStartPoint]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCleanDatabaseToStartPoint]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCleanUpOrphanedCategoryRecords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCleanUpOrphanedCategoryRecords]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCleanUpOrphanedRecords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCleanUpOrphanedRecords]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpCustomerInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpCustomerInfo]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteCustomer]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteCustomer]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteItem]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteItem]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteLocation]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteLocation]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteManufacturer]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteManufacturer]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteSite]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteSite]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpDeleteSupplier]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpDeleteSupplier]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetNextId]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetNextId]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetNextSN]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetNextSN]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetPendingAdjusts]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetPendingAdjusts]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpInactivateInvoice]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpInactivateInvoice]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpInactivatePo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpInactivatePo]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpInsertImage]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpInsertImage]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpInventoryTempDataSet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpInventoryTempDataSet]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpItemSummary]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpItemSummary]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpManufacturerInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpManufacturerInfo]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpNotCountedItems]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpNotCountedItems]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSetupWaspReader]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSetupWaspReader]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSetupInventoryReader]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSetupInventoryReader]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Audits]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Audits]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4InventoriesAdjust]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4InventoriesAdjust]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4InventoriesCheckInOut]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4InventoriesCheckInOut]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4InventoriesMove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4InventoriesMove]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Customers]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Customers]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Inventories]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Inventories]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Items]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Items]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Locations]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Locations]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Manufacturers]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Manufacturers]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Sites]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Sites]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSumNotes4Vendors]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSumNotes4Vendors]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpSupplierInfo]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpSupplierInfo]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpTransactionTempDataSet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpTransactionTempDataSet]
GO

if EXISTS (select * from dbo.sysobjects where id = object_id(N'[dbo].[SpGetTop10ItemsFromTransaction]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SpGetTop10ItemsFromTransaction]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpSumNotes4CheckOut]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpSumNotes4CheckOut]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpTransactionHistory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpTransactionHistory]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpMoveTransactions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpMoveTransactions]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpMoveTransactionsWithCost]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpMoveTransactionsWithCost]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpCustomerTransactionHistory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpCustomerTransactionHistory]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpItemSummaryReport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpItemSummaryReport]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpSitesLocations]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpSitesLocations]
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpMoveItemCostRecords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpMoveItemCostRecords]
GO

IF Exists (SELECT * FROM dbo.sysobjects where id = object_id(N'[dbo].[SpFixZeroCost]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SpFixZeroCost]
GO




print '----------------------------'
print '--                          '
print '--  CREATE PROC SECTION     '
print '--                          '
print '----------------------------'



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE PROCEDURE SpActivityReport 
	(@pStartDate datetime,  
	 @pEndDate datetime,
	 @pCompanyId int = 1) 
AS

/*
declare @pStartDate datetime
declare @pEndDate datetime

select @pStartDate = '06/01/2004'
select @pEndDate = '06/30/2004'
*/
--------------------------------------------------
-- Variable use for calucation
--------------------------------------------------
declare @vItemId 			int
declare @vAddTotal 			decimal
declare @vRemoveTotal 		decimal
declare @vAdjustInTotal		decimal
declare @vAdjustOutTotal	decimal
declare @vAuditOutTotal		decimal
declare @vStartTotal 		decimal
declare @vEndTotal 			decimal

--------------------------------------------------
-- Create the temporary table for storing balances
--------------------------------------------------
CREATE TABLE [#TEMP_TOTALS] (
	[item_id] 			[int] 			NOT NULL ,
	[start_date] 		[datetime] 			NULL ,
	[start_total] 		[decimal](18, 4) 	NULL ,
	[add_total] 		[decimal](18, 4) 	NULL ,
	[remove_total] 		[decimal](18, 4) 	NULL ,
	[adjust_out_total] 	[decimal](18, 4)	NULL ,
	[adjust_in_total] 	[decimal](18, 4)	NULL ,
	[audit_out_total]	[decimal](18, 4)	NULL ,
	[end_total] 		[decimal](18, 4)	NULL ,
	[end_date] 			[datetime] 			NULL
) ON [PRIMARY]


------------------------------------------------------
-- Set the end date to the first day of the next month
------------------------------------------------------
select @pEndDate = @pEndDate + 1;

--------------------------------------------------
-- Select unique list of ids to process
--------------------------------------------------

DECLARE MyCursor CURSOR
   FOR
   SELECT DISTINCT item_id FROM inventory_transactions 
		WHERE trans_date >= @pStartDate 
				and trans_date <= @pEndDate
				and record_status in (1,2)
				and company_id = @pCompanyId
				and trans_type not in (200,250,300,350)

OPEN MyCursor

FETCH NEXT FROM MyCursor INTO @vItemId
WHILE (@@FETCH_STATUS <> -1)
BEGIN
		
	--------------------------------------------------
	-- Transaction Types
	--------------------------------------------------
	--		Add			= 100						 
	--		Remove		= 150
	--		MoveIn		= 200
	--		MoveOut		= 250			
	--		CheckIn		= 300
	--		CheckOut	= 350
	--		AdjustIn	= 400
	--		AdjustOut	= 450			
	--		AuditIn		= 500
	--		Audit		= 550
	--------------------------------------------------
	
	--------------------------------------------------
	-- Get the totals for transactions after the end
	-- date so we can back them out of the total.
	--------------------------------------------------
	select @vAddTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type = 100 and trans_date >= @pEndDate and record_status in (1,2)
 	
	select @vRemoveTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type = 150 and trans_date >= @pEndDate and record_status in (1,2)
	
	select @vAdjustInTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (400,500) and trans_date >= @pEndDate and record_status in (1,2)

	select @vAdjustOutTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (450) and trans_date >= @pEndDate and record_status in (1,2)
		
	select @vAuditOutTotal = isnull(sum(current_qty),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (550) and trans_date >= @pEndDate and record_status in (1,2)

	--------------------------------------------------
	-- Calculate the ending Total
	--------------------------------------------------
	select @vEndTotal = sum(quantity) - @vAddTotal + @vRemoveTotal - @vAdjustInTotal + @vAdjustOutTotal + @vAuditOutTotal
		from inventory 
			where item_id = @vItemId

	print '****** Total After End Date ********'
	print '@vItemId..........' + convert(varchar,@vItemId)
	print '@vAddTotal........' + convert(varchar,@vAddTotal)
	print '@vRemoveTotal.....' + convert(varchar,@vRemoveTotal)
	print '@vAdjustInTotal...' + convert(varchar,@vAdjustInTotal)
	print '@vAdjustOutTotal..' + convert(varchar,@vAdjustOutTotal)
	print '@vAuditOutTotal...' + convert(varchar,@vAuditOutTotal)
	print '@vEndTotal........' + convert(varchar,@vEndTotal)

	--------------------------------------------------
	-- Get the totals for transactions between
	-- then start and end dates
	--------------------------------------------------
	select @vAddTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type = 100 
				and trans_date < @pEndDate 
				and trans_date >= @pStartDate 
				and record_status in (1,2)
 	
	select @vRemoveTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type = 150 
				and trans_date < @pEndDate 
				and trans_date >= @pStartDate 
				and record_status in (1,2)
	
	select @vAdjustInTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (400,500) 
				and trans_date < @pEndDate 
				and trans_date >= @pStartDate 
				and record_status in (1,2)

	select @vAdjustOutTotal = isnull(sum(quantity),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (450) 
				and trans_date < @pEndDate 
				and trans_date >= @pStartDate 
				and record_status in (1,2)
				
	select @vAuditOutTotal = isnull(sum(current_qty),0) from inventory_transactions 
		where item_id = @vItemId and trans_type in (550) 
				and trans_date < @pEndDate 
				and trans_date >= @pStartDate 
				and record_status in (1,2)

	--------------------------------------------------
	-- Calculate the beginning total
	--------------------------------------------------
	select @vStartTotal = @vEndTotal - @vAddTotal + @vRemoveTotal - @vAdjustInTotal + @vAdjustOutTotal + @vAuditOutTotal
	
	print '****** Between Totals'
	print '@vItemId..........' + convert(varchar,@vItemId)
	print '@vAddTotal........' + convert(varchar,@vAddTotal)
	print '@vRemoveTotal.....' + convert(varchar,@vRemoveTotal)
	print '@vAdjustInTotal...' + convert(varchar,@vAdjustInTotal)
	print '@vAdjustOutTotal..' + convert(varchar,@vAdjustOutTotal)
	print '@vAuditOutTotal...' + convert(varchar,@vAuditOutTotal)
	print '@vStartTotal......' + convert(varchar,@vStartTotal)

	insert into #TEMP_TOTALS (	item_id, 
								start_date, 
								start_total,
								end_date,
								end_total,
								add_total,
								remove_total,
								adjust_out_total,
								adjust_in_total,
								audit_out_total)
		values
							(	@vItemId,
								@pStartDate,
								@vStartTotal,
								@pEndDate - 1,
								@vEndTotal,
								@vAddTotal,
								@vRemoveTotal,
								@vAdjustOutTotal,
								@vAdjustInTotal,
								@vAuditOutTotal)

	FETCH NEXT FROM MyCursor INTO @vItemId
END

DEALLOCATE MyCursor

--------------------------------------------------
-- Return the temp table to the call routing
--------------------------------------------------
select 	i.item_number, 
		i.description, 
		t.start_date, 
		t.start_total,
		t.add_total,
		t.remove_total,
		t.adjust_in_total,
		t.adjust_out_total,
		t.audit_out_total,
		t.end_total,
		t.end_date
	from #TEMP_TOTALS t, ITEM i 
	where i.item_id = t.item_id

--------------------------------------------------
-- Delete the temporary table
--------------------------------------------------
drop table [#TEMP_TOTALS]



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE PROCEDURE SpArchiveInventoryTransactions
(@pItemId int, @pEarlyDate datetime)
AS
declare @vEntryDate 	datetime
declare @vTransDate 	datetime
declare @vAcquiredDate 	datetime
declare @vRecordCount   int

/****************************************/
/* Set Default value                    */
/****************************************/
/* Test values
Select @pEarlyDate = getdate()
select @pItemId = 462
*/

select @vRecordCount = 0


print '************ Step 0 **************'
/*
select pick_order_id from inventory_transactions where pick_order_id <> 0 and item_id = @pItemId
select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId
*/
/***************************************************************************** 
 * Get the earliest posible date base on the transactions for this item_id 
 * only
 *****************************************************************************/
print '--------------------------------------------'
print @pEarlyDate
print 'Step 1'
print '--------------------------------------------'
/*
select item_id, pick_order_id, po_id, entry_date, trans_date, date_acquired from inventory_transactions where record_status not in (2,3) and item_id = @pItemId
*/

select @vEntryDate = min(entry_date) from inventory_transactions where record_status not in (2,3) and item_id = @pItemId

select @vTransDate = min(trans_date) from inventory_transactions where record_status not in (2,3) and item_id = @pItemId

select @vAcquiredDate = min(date_acquired) from inventory_transactions where record_status not in (2,3) and item_id = @pItemId

/* Check the entry date */
if (@vEntryDate < @pEarlyDate)
begin
	select @pEarlyDate = @vEntryDate
end

/* Check the trans date */
if (@vTransDate < @pEarlyDate)
begin
	select @pEarlyDate = @vTransDate
end

/* Check the acquired date */
if (@vAcquiredDate < @pEarlyDate)
begin
	select @pEarlyDate = @vAcquiredDate
end

print '--------------------------------------------'
print @pEarlyDate

/***************************************************************************** 
 * Get the earliest posible date based on the invoice transactions 
 * associated with the item id.  For example:  if item 55 is the item we are
 * working on and item 88 is on an invoice with 55 we would use the earliest
 * date of the two.  We do this in order to keep all the transactions for an
 * invoice together.
 *****************************************************************************/

print 'Step 2'
print '--------------------------------------------'

/*
	select item_id, pick_order_id, entry_date, trans_date, date_acquired 
		from inventory_transactions 
		where record_status not in (2,3) and 
			  pick_order_id in (select pick_order_id from inventory_transactions where pick_order_id <> 0 and item_id = @pItemId)
*/

select @vEntryDate = min(entry_date) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 150)

select @vTransDate = min(trans_date) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 150)

select @vAcquiredDate = min(date_acquired) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 150)

if (@vEntryDate < @pEarlyDate)
begin
	select @pEarlyDate = @vEntryDate
end

/* Check the trans date */
if (@vTransDate < @pEarlyDate)
begin
	select @pEarlyDate = @vTransDate
end

/* Check the acquired date */
if (@vAcquiredDate < @pEarlyDate)
begin
	select @pEarlyDate = @vAcquiredDate
end

print '--------------------------------------------'
print @pEarlyDate

/***************************************************************************** 
 * Get the earliest posible date based on the po transactions 
 * associated with the item id.  For example:  if item 55 is the item we are
 * working on and item 88 is on an po with 55 we would use the earliest
 * date of the two.  We do this in order to keep all the transactions for an
 * po together.
 *****************************************************************************/

print 'Step 3'
print '--------------------------------------------'
/*
	select item_id, po_id, entry_date, trans_date, date_acquired 
		from inventory_transactions 
		where record_status not in (2,3) and 
			  po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId)
*/

select @vEntryDate = min(entry_date) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 100)

select @vTransDate = min(trans_date) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 100)

select @vAcquiredDate = min(date_acquired) from inventory_transactions
				where record_status not in (2,3) and 
				po_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 100)

if (@vEntryDate < @pEarlyDate)
begin
	select @pEarlyDate = @vEntryDate
end

/* Check the trans date */
if (@vTransDate < @pEarlyDate)
begin
	select @pEarlyDate = @vTransDate
end

/* Check the acquired date */
if (@vAcquiredDate < @pEarlyDate)
begin
	select @pEarlyDate = @vAcquiredDate
end

print '--------------------------------------------'
print @pEarlyDate

/***************************************************************************** 
 * Get the earliest possible date based on the pick_order record_status  
 * date.  if an inventory_transaction for an item is inactive and the 
 * pick_order record_status is still have we do not want to archive the
 * inventory_transaction
 *****************************************************************************/

print 'Step 4'
print '--------------------------------------------'
/*
	select pick_order_id, record_status_date, record_status
		from pick_order
		where record_status not in (2,3) and 
			  pick_order_id in (select pick_order_id from inventory_transactions where pick_order_id <> 0 and item_id = @pItemId)
*/

select @vEntryDate = min(last_modified_date) from pick_order
				where record_status not in (2,3) and order_status not in(20,21) and 
				pick_order_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 150)

if (@vEntryDate < @pEarlyDate)
begin
	select @pEarlyDate = @vEntryDate
end

print '--------------------------------------------'
print @pEarlyDate

/***************************************************************************** 
 * Get the earliest possible date based on the purchase_orders record_status  
 * date.  if an inventory_transaction for an item is inactive and the 
 * pick_order record_status is still have we do not want to archive the
 * inventory_transaction
 *****************************************************************************/

print 'Step 5'
print '--------------------------------------------'
/*
	select po_id, record_status_date, record_status
		from purchase_orders
		where record_status not in (2,3) and 
			  po_id in (select po_id as po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId)
*/

select @vEntryDate = min(last_modified_date) from po_master
				where (record_status not in (2,3) and po_status not in (20,21)) and 
				po_id in (select po_id as po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 100)

if (@vEntryDate < @pEarlyDate)
begin
	select @pEarlyDate = @vEntryDate
end

print '--------------------------------------------'
print 'Date Used'
print @pEarlyDate
print '--------------------------------------------'

/*****************************************************************************
 * move the records to there counter part archive tables
 *****************************************************************************/

begin transaction


-----------------------------------------------------------------------------
-- PickOrders PickOrders PickOrders PickOrders PickOrders PickOrders PickOrders PickOrders 
-----------------------------------------------------------------------------
-- Move pick_order records
-----------------------------------------------------------------------------
print 'Moving Pick Order Records'
insert into pick_order_history
select *
	from  pick_order
	where order_status in (20,21) and
		  last_modified_date < @pEarlyDate and
		  pick_order_id in (select po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId and trans_type = 150)		
		  
-----------------------------------------------------------------------------
-- Move pick_order_ext records
-----------------------------------------------------------------------------
print 'Moving Pick Order Extension Records'
insert into pick_order_ext_history
select *
	from  pick_order_ext
	where pick_order_id in (select pick_order_id from pick_order_history) 

-----------------------------------------------------------------------------
-- Move invoice line item records
-----------------------------------------------------------------------------
print 'Moving Pick Order Detail Records'
insert into pick_order_detail_history
select *
	from  pick_order_detail
    where pick_order_id in (select pick_order_id from pick_order_history)
    
-----------------------------------------------------------------------------
-- Move invoice line item extension records
-----------------------------------------------------------------------------
print 'Moving Pick Order Detail Extension Records'
insert into pick_order_detail_ext_history
select pick_order_detail_id, price, sales_tax_code_id, external_key
	from  pick_order_detail_ext
    where pick_order_detail_id in (select pick_order_detail_id from pick_order_detail_history)
    
-----------------------------------------------------------------------------
-- Delete invoice ext line item records
-----------------------------------------------------------------------------

delete from pick_order_detail_ext
    where pick_order_detail_id in (select pick_order_detail_id from pick_order_detail_history)

set @vRecordCount = @vRecordCount + @@rowcount

-----------------------------------------------------------------------------
-- Delete invoice_master_ext line item records
-----------------------------------------------------------------------------

delete from pick_order_ext
    where pick_order_id in (select pick_order_id from pick_order_history)

set @vRecordCount = @vRecordCount + @@rowcount

-----------------------------------------------------------------------------
-- Delete invoice line item records
-----------------------------------------------------------------------------

delete from pick_order_detail
    where pick_order_id in (select pick_order_id from pick_order_history)

set @vRecordCount = @vRecordCount + @@rowcount
-----------------------------------------------------------------------------
-- Delete invoice_maseter records
-----------------------------------------------------------------------------

delete from pick_order
    where pick_order_id in (select pick_order_id from pick_order_history)

set @vRecordCount = @vRecordCount + @@rowcount
-----------------------------------------------------------------------------
-- POs POs POs POs POs POs POs POs POs POs POs POs POs POs POs POs POs POs
-----------------------------------------------------------------------------
-- Move purhcase_orders records
-----------------------------------------------------------------------------
print 'Moving Purchase Orders'
insert into po_master_history
select *
	from  po_master
	where po_status in (20,21) and
		  last_modified_date < @pEarlyDate and
		  po_id in (select po_id as po_id from inventory_transactions where po_id <> 0 and item_id = @pItemId)		  

-----------------------------------------------------------------------------
-- Move po_detail records
-----------------------------------------------------------------------------
print 'Moving Purchase Orders Line Items'
insert into po_detail_history
select *
	from  po_detail
    where po_id in (select po_id from po_master_history)

-----------------------------------------------------------------------------
-- Delete po_detail records
-----------------------------------------------------------------------------

delete from po_detail
    where po_id in (select po_id from po_master_history)

set @vRecordCount = @vRecordCount + @@rowcount
-----------------------------------------------------------------------------
-- Delete purhcase_orders records
-----------------------------------------------------------------------------

delete from po_master
    where po_id in (select po_id from po_master_history)

set @vRecordCount = @vRecordCount + @@rowcount


--	copy the old records into the history_transactions table

insert into history_transactions 
select *
	from inventory_transactions 
	where 	record_status in (2,3) and 
			item_id = @pItemId  and
			(entry_date < @pEarlyDate or entry_date is null) and
			(trans_date < @pEarlyDate or trans_date is null) and
			(date_acquired < @pEarlyDate or date_acquired is null)

--	delete the transactions from the inventory transactions table

delete
	from inventory_transactions 
	where 	record_status in (2,3) and 
			item_id = @pItemId  and
			(entry_date < @pEarlyDate or entry_date is null) and
			(trans_date < @pEarlyDate or trans_date is null) and
			(date_acquired < @pEarlyDate or date_acquired is null)

-- Add to the total number of record processed
set @vRecordCount = @vRecordCount + @@rowcount

-----------------------------------------------------------------------------
-- Return the number of records deleted 
-----------------------------------------------------------------------------

select @vRecordCount as records_moved

print '----------------------------------------'
print @vRecordCount
print '----------------------------------------'

commit transaction


GO



CREATE PROCEDURE SpAuditResults 
 
AS
SET NOCOUNT ON

declare @start_date  datetime 
declare @end_date datetime 

SELECT      top 1  @start_date  =  start_date, @end_date  =end_date
FROM         dbo.inv_audit
WHERE		 record_status = 1
order by start_date desc

 
if @end_date is null

SELECT  * from dbo.vAuditInfo   
where  trans_date >= @start_date
 order by trans_date desc 

else

SELECT  * from dbo.vAuditInfo   
where trans_date  between @start_date and @end_date
order by trans_date desc







GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE PROCEDURE [SpBackOrderTracking] AS
 
SET NOCOUNT ON

SELECT     dbo.customer.customer_number, dbo.customer.name AS customer_name, 
		dbo.invoice_master.invoice_id, dbo.invoice_master.ref_number AS invoice_number, 
                      dbo.invoice_master.due_date, dbo.invoice_master.line_item_count, 
		invoice_master_1.ref_number AS parent_invoice_number, 
                      invoice_master_3.ref_number AS back_order_invoice_number

 
FROM         dbo.invoice_master invoice_master_2 INNER JOIN
                      dbo.invoice_master ON invoice_master_2.invoice_id = dbo.invoice_master.backorder_id LEFT OUTER JOIN
                      dbo.invoice_master invoice_master_3 ON dbo.invoice_master.backorder_id = invoice_master_3.invoice_id LEFT OUTER JOIN
                      dbo.invoice_master invoice_master_1 ON dbo.invoice_master.parent_id = invoice_master_1.invoice_id LEFT OUTER JOIN
                      dbo.customer ON dbo.invoice_master.customer_id = dbo.customer.customer_id

union


SELECT     dbo.customer.customer_number, dbo.customer.name AS customer_name, 
		dbo.invoice_master.invoice_id, dbo.invoice_master.ref_number AS invoice_number, 
                      dbo.invoice_master.due_date, dbo.invoice_master.line_item_count, 
		invoice_master_1.ref_number AS parent_invoice_number, 
                      invoice_master_3.ref_number AS back_order_invoice_number 

FROM         dbo.invoice_master invoice_master_2 INNER JOIN
                      dbo.invoice_master ON invoice_master_2.invoice_id = dbo.invoice_master.parent_id LEFT OUTER JOIN
                      dbo.invoice_master invoice_master_3 ON dbo.invoice_master.backorder_id = invoice_master_3.invoice_id LEFT OUTER JOIN
                      dbo.invoice_master invoice_master_1 ON dbo.invoice_master.parent_id = invoice_master_1.invoice_id LEFT OUTER JOIN
                      dbo.customer ON dbo.invoice_master.customer_id = dbo.customer.customer_id
WHERE     (dbo.invoice_master.backorder_id = 0)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpCleanDatabaseToStartPoint
 
AS


delete from address
delete from auto_numbers
delete from company_info where company_id > 1
delete from find_meta
delete from import_export_errors
delete from inventory_transactions
delete from audit_transactions
delete from history_transactions
delete from customer where customer_id > 0
delete from inv_audit
delete from inventory
delete from item
delete from location where location_id > 0
delete from lookup
delete from manufacturer where manufacturer_id > 0
delete from notes
delete from phone
delete from sites where site_id > 0
delete from supplier where supplier_id > 0
delete from category where category_id > 0
delete from recent_values

insert into address (address_id, record_type, record_status) values	(1,'Company Corporate', 1)
insert into address (address_id, record_type, record_status) values (1,'Company Receiving', 1)
insert into address (address_id, record_type, record_status) values	(1,'Company Shipping', 1)

insert into phone (phone_id, record_type, record_status) values (1,'Company Fax', 1)
insert into phone (phone_id, record_type, record_status) values (1,'Company Phone', 1)

/* 
	Reset the company info record 
	The should only be 1 record in the company info table at this point
*/
print 'Updating Company Info...'
update company_info set company = '', email = '', website = ''

/* 
	reset the meta data to the default values 
*/
print 'Resetting default values...'
update form_field_meta 
	set 
	label = default_label,
	tool_tip = default_tool_tip,
	visible = default_visible,
	required = default_required,
	field_length = default_field_length





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE SpCleanUpOrphanedCategoryRecords (@pCompanyId int) AS

if (select count(*) from category where 
	category_id not in (select distinct c.category_id from category c inner join item i on c.category_id=i.category_id where c.company_id=@pCompanyId and i.record_status=1 and c.record_status=1)  and 
	record_status = 1 and 
	company_id = @pCompanyId) > 0
begin
	update category
	set record_status = 2
	where category_id in (select distinct category_id from category where 
		category_id not in (select distinct c.category_id from category c inner join item i on c.category_id=i.category_id where c.company_id=@pCompanyId and i.record_status=1 and c.record_status=1) and 
		record_status = 1 and 
		company_id = @pCompanyId)
	and company_id = @pCompanyId;	
end

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE SpCleanUpOrphanedRecords (@pCompanyId int) AS

if (select count(*) from customer 
    where 
	customer_id not in (select distinct phone_id from phone where table_name = 'customer' and record_status = 1) and 
	record_status = 1 and 
	company_id = @pCompanyId) > 0
begin
	update address
	set record_status = 2
	where address_id in (select distinct customer_id from customer 
				where customer_id not in (select distinct phone_id from phone 
						       		where table_name = 'customer' and 
						             			record_status = 1) and 
 	  			  	record_status = 1 and 
					company_id = @pCompanyId) and 
	table_name='customer';
	
	update notes
	set record_status = 2
	where note_id in (select distinct customer_id from customer where 
			customer_id not in (select distinct phone_id from phone 
					    where table_name = 'customer' and 
						  record_status = 1) and 
			record_status = 1 and 
			company_id =@pCompanyId)
	and table_name ='customer';

	update customer 
	set record_status = 2
	where customer_id in (select distinct customer_id from customer where 
		customer_id not in (select distinct phone_id from phone where table_name = 'customer' and record_status = 1) and 
		record_status = 1 and 
		company_id = @pCompanyId)
	and company_id = @pCompanyId;	
end

if (select count(*) from supplier where 
	supplier_id not in (select distinct phone_id from phone where table_name = 'supplier' and record_status = 1) and 
	record_status = 1 and 
	company_id = @pCompanyId) > 0
begin
	update address
	set record_status = 2
	where address_id in (select distinct supplier_id from supplier where 
			supplier_id not in (select distinct phone_id from phone where table_name = 'supplier' and record_status = 1) and 
			record_status = 1 and 
			company_id = @pCompanyId)
	and table_name='supplier';
	
	update notes
	set record_status = 2
	where note_id in (select distinct supplier_id from supplier where 
			supplier_id not in (select distinct phone_id from phone where table_name = 'supplier' and record_status = 1) and 
			record_status = 1 and 
			company_id =@pCompanyId)
	and table_name ='supplier';

	update supplier 
	set record_status = 2
	where supplier_id in (select distinct supplier_id from supplier where 
		supplier_id not in (select distinct phone_id from phone where table_name = 'supplier' and record_status = 1) and 
		record_status = 1 and 
		company_id = @pCompanyId)
	and company_id = @pCompanyId;	
end

if (select count(*) from manufacturer where 
	manufacturer_id not in (select distinct phone_id from phone where table_name = 'manufacturer' and record_status = 1) and 
	record_status = 1 and 
	company_id = @pCompanyId) > 0
begin
	update address
	set record_status = 2
	where address_id in (select distinct manufacturer_id from manufacturer where 
			manufacturer_id not in (select distinct phone_id from phone where table_name = 'manufacturer' and record_status = 1) and 
			record_status = 1 and 
			company_id = @pCompanyId)
	and table_name='manufacturer';
	
	update notes
	set record_status = 2
	where note_id in (select distinct manufacturer_id from manufacturer where 
			manufacturer_id not in (select distinct phone_id from phone where table_name = 'manufacturer' and record_status = 1) and 
			record_status = 1 and 
			company_id = @pCompanyId)
	and table_name ='manufacturer';

	update manufacturer 
	set record_status = 2
	where manufacturer_id in (select distinct manufacturer_id from manufacturer where 
		manufacturer_id not in (select distinct phone_id from phone where table_name = 'manufacturer' and record_status = 1) and 
		record_status = 1 and 
		company_id = @pCompanyId)
	and company_id = @pCompanyId;	
end

if (select count(*) from category where 
	category_id not in (select distinct category_id from item where record_status = 1) 
	and record_status = 1
	and company_id = @pCompanyId ) > 0
begin
	update category
	set record_status = 2
	where category_id not in ( select distinct category_id from item where record_status = 1) 
	and record_status = 1
	and company_id = @pCompanyId
end
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO








CREATE PROCEDURE SpCustomerInfo


AS
SET NOCOUNT ON

SELECT     
customer_id, 
customer_number, 
dbo.customer.name, 
company_name, 
email, 
department, 
date_added, 
record_status,
company_id

into #t1
FROM         dbo.customer

select  Customer_id, phone_number, extension
into #t2
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=1

select  Customer_id,phone_number as 'Fax'
into #t3
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=3

select Customer_id,phone_number as 'hPhone' 
into #t4
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=4

select Customer_id,phone_number as 'cCell' 
into #t5
FROM         dbo.Customer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Customer.Customer_id AND  dbo.phone.table_name = 'Customer' and dbo.phone.phone_type_id=2



SET NOCOUNT OFF

SELECT     
#t1.Customer_id, 
customer_number,
#t1.name, 
company_name, 
email, 
department, 
date_added, 
record_status,
company_id,
phone_number, 
extension,
fax,
hphone,
ccell


from #t1 inner join #t2 on #t1.Customer_id = #t2.Customer_id
inner join #t3 on #t3.Customer_id = #t2.Customer_id
inner join #t4 on #t4.Customer_id = #t2.Customer_id
inner join #t5 on #t5.Customer_id = #t2.Customer_id
where #t1.Customer_id >0

drop table #t1
drop table #t2
drop table #t3
drop table #t4
drop table #t5







GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpDeleteCustomer (@pStatus int, @pCustomerId int, @pCompanyId int) AS

update customer set record_status = @pStatus  where customer_id = @pCustomerId and company_id = @pCompanyId
update address set record_status = @pStatus  where address_id = @pCustomerId and table_name = 'customer'
update phone set record_status = @pStatus  where phone_id = @pCustomerId and table_name = 'customer'

UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id  = @pCustomerId) AND (table_name = 'customer')

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpDeleteItem (@pStatus int, @pItemId int, @pCompanyId int) AS

update item set record_status = @pStatus  where item_id = @pItemId and company_id = @pCompanyId
UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id  = @pItemId) AND (table_name = 'item')

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpDeleteLocation (@pStatus int, @pLocationId int, @pCompanyId int) AS

update location set record_status = @pStatus  where location_id = @pLocationId and company_id = @pCompanyId

UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id  = @pLocationId) AND (table_name = 'location')

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpDeleteManufacturer (@pStatus int, @pManufacturerId int, @pCompanyId int) AS

update manufacturer set record_status = @pStatus  where manufacturer_id = @pManufacturerId and company_id = @pCompanyId

update phone set record_status = @pStatus  where phone_id = @pManufacturerId and table_name = 'manufacturer'

UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id  = @pManufacturerId) AND (table_name = 'manufacturer')

update address set record_status = @pStatus  where address_id = @pManufacturerId and table_name = 'manufacturer'

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpDeleteSite (@pStatus int, @pSiteId int, @pCompanyId int) AS

update sites set record_status = @pStatus  where site_id = @pSiteId and company_id = @pCompanyId

UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id = @pSiteId) AND (table_name = 'sites')

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO





SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE PROCEDURE SpDeleteSupplier (@pStatus int, @pSupplierId int, @pCompanyId int) AS

update supplier set record_status = @pStatus  where supplier_id = @pSupplierId and company_id = @pCompanyId
update phone set record_status = @pStatus  where phone_id = @pSupplierId and table_name = 'supplier'

UPDATE    notes
SET              record_status = @pStatus
WHERE     (note_id = @pSupplierId) AND (table_name = 'supplier')

update address set record_status = @pStatus  where address_id = @pSupplierId and LEFT(record_type, 8) = 'Supplier'




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE PROCEDURE [SpGetNextId] (@pObjectType varchar(50), @pCompanyId int, @pStartNumber numeric(30,0) = 0) AS
declare @vNextId numeric(30,0)

set nocount on

begin transaction

if (SELECT count(*) FROM auto_numbers  WHERE object_type = @pObjectType and company_id = @pCompanyId) =  0
begin
	select @vNextId = @pStartNumber
	insert into auto_numbers(object_type, company_id, next_id) values (@pObjectType, @pCompanyId, @vNextId + 1)
end
else
begin
	select @vNextId = next_id  from auto_numbers  with (holdlock) where object_type = @pObjectType and company_id = @pCompanyId
	update auto_numbers set next_id = @vNextId + 1 where object_type = @pObjectType and company_id = @pCompanyId
end

commit transaction

select @vNextId as next_id

set nocount off



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE SpGetNextSN (@pItemId int) AS

declare @vNextId numeric(30,0)

begin transaction

begin
	select @vNextId = auto_sn_value  from item  with (holdlock) where item_id = @pItemId
	if (@vNextId = 0)
	begin
		select @vNextId = 1
	end 
	update item set auto_sn_value = @vNextId + 1 where item_id = @pItemId
end

commit transaction

select @vNextId as next_id


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE   PROCEDURE dbo.SpGetPendingAdjusts (@pUserId int, @pCompanyId int, @pDecimalPlace int, @pMachineName varchar(30))AS

select transaction_id, quantity, serial_number,
adjust_type_text = CASE adjust_type WHEN 'a' THEN 'absolute_adjust' WHEN 'r' THEN 'relative_adjust' WHEN 's' THEN 'absolute_adjust' END,
lot, date_code, pallet, adjust_trans_code, adjust_reason_id, inventory_id, record_status, company_id, user_id,
trans_type, record_source  INTO #tt1 from inventory_transactions;

IF (@pDecimalPlace = 0)
BEGIN
SELECT t.transaction_id,  i.item_number, i.description, s.site_name,l.code,
CONVERT(decimal(18, 0), t.quantity) AS quantity,
t.serial_number, f.label as adjust_type, r.adjust_code, t.lot, t.date_code, t.pallet,
t.adjust_trans_code
FROM   #tt1  t INNER JOIN
reasons_adjustment r ON t.adjust_reason_id = r.reason_id
INNER JOIN inventory inv ON t .inventory_id = inv.inventory_id INNER JOIN
item i ON inv.item_id = i.item_id INNER JOIN location l ON inv.location_id = l.location_id
inner join sites s on s.site_id = l.site_id cross JOIN   form_field_meta f
WHERE     (t.record_status = 4) AND (t.company_id = @pCompanyId) AND (t.user_id = @pUserId) AND
(t.trans_type = 450) AND (f.form_id = 21) and (t.adjust_type_text=f.field) and (t.record_source = @pMachineName)
END
ELSE
IF (@pDecimalPlace = 1)
BEGIN
SELECT t.transaction_id,  i.item_number, i.description, s.site_name,l.code,
CONVERT(decimal(18, 1), t.quantity) AS quantity,
t.serial_number, f.label as adjust_type, r.adjust_code, t.lot, t.date_code, t.pallet,
t.adjust_trans_code
FROM   #tt1  t INNER JOIN
reasons_adjustment r ON t.adjust_reason_id = r.reason_id
INNER JOIN inventory inv ON t .inventory_id = inv.inventory_id INNER JOIN
item i ON inv.item_id = i.item_id INNER JOIN location l ON inv.location_id = l.location_id
inner join sites s on s.site_id = l.site_id cross JOIN   form_field_meta f
WHERE     (t.record_status = 4) AND (t.company_id = @pCompanyId) AND (t.user_id = @pUserId) AND
(t.trans_type = 450) AND (f.form_id = 21) and (t.adjust_type_text=f.field) and (t.record_source = @pMachineName)
END
ELSE
IF (@pDecimalPlace = 2)
BEGIN
SELECT t.transaction_id,  i.item_number, i.description, s.site_name,l.code,
CONVERT(decimal(18, 2), t.quantity) AS quantity,
t.serial_number, f.label as adjust_type, r.adjust_code, t.lot, t.date_code, t.pallet,
t.adjust_trans_code
FROM   #tt1  t INNER JOIN
reasons_adjustment r ON t.adjust_reason_id = r.reason_id
INNER JOIN inventory inv ON t .inventory_id = inv.inventory_id INNER JOIN
item i ON inv.item_id = i.item_id INNER JOIN location l ON inv.location_id = l.location_id
inner join sites s on s.site_id = l.site_id cross JOIN   form_field_meta f
WHERE     (t.record_status = 4) AND (t.company_id = @pCompanyId) AND (t.user_id = @pUserId) AND
(t.trans_type = 450) AND (f.form_id = 21) and (t.adjust_type_text=f.field) and (t.record_source = @pMachineName)
END
ELSE
IF (@pDecimalPlace = 3)
BEGIN
SELECT t.transaction_id,  i.item_number, i.description, s.site_name,l.code,
CONVERT(decimal(18, 3), t.quantity) AS quantity,
t.serial_number, f.label as adjust_type, r.adjust_code, t.lot, t.date_code, t.pallet,
t.adjust_trans_code
FROM   #tt1  t INNER JOIN
reasons_adjustment r ON t.adjust_reason_id = r.reason_id
INNER JOIN inventory inv ON t .inventory_id = inv.inventory_id INNER JOIN
item i ON inv.item_id = i.item_id INNER JOIN location l ON inv.location_id = l.location_id
inner join sites s on s.site_id = l.site_id cross JOIN   form_field_meta f
WHERE     (t.record_status = 4) AND (t.company_id = @pCompanyId) AND (t.user_id = @pUserId) AND
(t.trans_type = 450) AND (f.form_id = 21) and (t.adjust_type_text=f.field) and (t.record_source = @pMachineName)
END
ELSE
BEGIN
SELECT t.transaction_id,  i.item_number, i.description, s.site_name,l.code,
CONVERT(decimal(18, 4), t.quantity) AS quantity,
t.serial_number, f.label as adjust_type, r.adjust_code, t.lot, t.date_code, t.pallet,
t.adjust_trans_code
FROM   #tt1  t INNER JOIN
reasons_adjustment r ON t.adjust_reason_id = r.reason_id
INNER JOIN inventory inv ON t .inventory_id = inv.inventory_id INNER JOIN
item i ON inv.item_id = i.item_id INNER JOIN location l ON inv.location_id = l.location_id
inner join sites s on s.site_id = l.site_id cross JOIN   form_field_meta f
WHERE     (t.record_status = 4) AND (t.company_id = @pCompanyId) AND (t.user_id = @pUserId) AND
(t.trans_type = 450) AND (f.form_id = 21) and (t.adjust_type_text=f.field) and (t.record_source = @pMachineName)
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE PROCEDURE SpInactivateInvoice 
(@pInvoiceId int)
AS
/*******************************************************************************************************/
/* Update the record status on the invoice and its line items to inactive                           */
/******************************************************************************************************/
begin transaction

	update invoice_master set record_status = 2,
				  record_status_date =  getdate()
						where invoice_id = @pInvoiceId

	update invoice_line_items set record_status = 2 where invoice_id = @pInvoiceId

commit transaction

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE PROCEDURE SpInactivatePo
(@pPoId int)
AS
/*******************************************************************************************************/
/* Update the record status on the invoice and its line items to inactive                           */
/******************************************************************************************************/
begin transaction

	update purchase_orders set record_status = 2,
				  record_status_date =  getdate()
						where purchase_order_id = @pPoId

	update po_line_item set record_status = 2 where purchase_order_id = @pPoId

commit transaction

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE PROCEDURE dbo.SpInsertImage (@image_id int, @image_label text, @image binary) AS
INSERT INTO image
                      (image_id, image_label, image)
VALUES     (@image_id, @image_label, @image)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go


CREATE PROCEDURE [SpInventoryTempDataSet]  
@nUserID int,
@sSql varchar(1000)
AS
BEGIN

	-- If the temp table EXISTS drop it
	IF OBJECT_ID('tempdb..#inventory_temp') IS NOT NULL
	begin
	   DROP TABLE   #inventory_temp;
		print 'Table Dropped'
	end

	declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	CREATE TABLE #inventory_temp
	(
		item_number varchar(31), 
		item_desc varchar(255), 
		site_name  varchar(30), 
		code varchar(30), 
		pallet varchar(30), 
		lot  varchar(30), 
		po varchar(38), 
		date_code varchar(30), 
		serial_number varchar(30), 
		quantity decimal,
		supplier_number varchar(30),
		date_acquired datetime,
		min_stock_level decimal,
		max_stock_level decimal,
		reorder_qty decimal,
		category varchar(255)
	)

	--if user has privilege on one or more site
	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end

		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			INSERT  #inventory_temp
			SELECT  item.item_number, item.description AS item_desc, sites.site_name, location.code, trn.pallet, trn.lot, trn.po, trn.date_code, 
					trn.serial_number, SUM(trn.remaining_qty) AS quantity, supplier.supplier_number, trn.date_acquired, 
					inv.min_stock_level, inv.max_stock_level, inv.reorder_qty, category.description AS category
			FROM  inventory_transactions trn INNER JOIN
				  inventory inv ON trn.inventory_id = inv.inventory_id INNER JOIN
				  item ON inv.item_id = item.item_id INNER JOIN
				  location ON inv.location_id = location.location_id INNER JOIN
				  sites ON location.site_id = sites.site_id and sites.site_id <> 0 INNER JOIN
				  customer ON trn.customer_id = customer.customer_id INNER JOIN
				  supplier ON trn.supplier_id = supplier.supplier_id INNER JOIN 
				  category ON item.category_id = category.category_id
			WHERE	(trn.record_status IN (1 )) 
			AND		(trn.company_id = 1) 
			AND		(trn.trans_type IN (150, 250, 450, 100, 200, 400, 500 ) )
			AND		(inv.location_id IN ( SELECT loc.location_id FROM   location loc))
			GROUP BY	trn.pallet, 
						trn.lot, 
						trn.po,
						trn.date_code, 
						trn.serial_number, 
						item.item_number, 
						item.description, 
						sites.site_name, 
						location.code, 
						supplier.supplier_number, 
						supplier.name, 
						trn.date_acquired,
						inv.min_stock_level,
						inv.max_stock_level, 
						inv.reorder_qty, 
						category.description
		end
		else
		begin
			INSERT  #inventory_temp
			SELECT  item.item_number, item.description AS item_desc, sites.site_name, location.code, trn.pallet, trn.lot, trn.po, trn.date_code, 
					trn.serial_number, SUM(trn.remaining_qty) AS quantity, supplier.supplier_number, trn.date_acquired, 
					inv.min_stock_level, inv.max_stock_level, inv.reorder_qty, category.description AS category
			FROM  inventory_transactions trn INNER JOIN
				  inventory inv ON trn.inventory_id = inv.inventory_id INNER JOIN
				  item ON inv.item_id = item.item_id INNER JOIN
				  location ON inv.location_id = location.location_id INNER JOIN
				  sites ON location.site_id = sites.site_id and sites.site_id <> 0 INNER JOIN
				  customer ON trn.customer_id = customer.customer_id INNER JOIN
				  supplier ON trn.supplier_id = supplier.supplier_id INNER JOIN 
				  category ON item.category_id = category.category_id
			WHERE	(trn.record_status IN (1 )) 
			AND		(trn.company_id = 1) 
			AND		(trn.trans_type IN (150, 250, 450, 100, 200, 400, 500 ) )
			AND		(inv.location_id IN ( SELECT loc.location_id FROM location loc
										  where  loc.site_id in ( select site_id from user_site where user_id = @nUserID )))
			GROUP BY	trn.pallet, 
						trn.lot, 
						trn.po,
						trn.date_code, 
						trn.serial_number, 
						item.item_number, 
						item.description, 
						sites.site_name, 
						location.code, 
						supplier.supplier_number, 
						supplier.name, 
						trn.date_acquired,
						inv.min_stock_level,
						inv.max_stock_level, 
						inv.reorder_qty, 
						category.description
		end
	end

	execute(@sSql)

	drop table #inventory_temp
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO







CREATE PROCEDURE SpItemSummary
 
AS
SET NOCOUNT ON
 
create table ##jds
(
	item_id int,
	quantity decimal,
	location_id int
)

insert into ##jds select item_id, 0.0 as quantity, 0 as location_id from item where item_id not 

in (select item_id from inventory)

insert into ##jds select item_id, quantity,location_id from inventory

SELECT     dbo.item.item_number, dbo.item.description, dbo.item.cost, dbo.item.avgcost, dbo.category.description AS catagory, 
                      dbo.manufacturer.name AS manufacturer, dbo.supplier.name AS supplier, dbo.item.min_stock_level, dbo.item.reorder_qty, 
                      dbo.item.record_status AS itemStatus, dbo.item.company_id, 
                      dbo.location.code, dbo.sites.description AS siteDes, dbo.location.description AS locationDes, ##jds.quantity
FROM         dbo.item inner JOIN
                      ##jds ON dbo.item.item_id = ##jds.item_id INNER JOIN
                      dbo.category ON dbo.item.category_id = dbo.category.category_id INNER JOIN
                      dbo.manufacturer ON dbo.item.manufacturer_id = dbo.manufacturer.manufacturer_id INNER JOIN
                      dbo.supplier ON dbo.item.supplier_id = dbo.supplier.supplier_id INNER JOIN
                      dbo.location ON dbo.location.location_id = ##jds.location_id INNER JOIN
                      dbo.sites ON dbo.sites.site_id = dbo.location.site_id


drop table ##jds






GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO








CREATE PROCEDURE SpManufacturerInfo


AS
SET NOCOUNT ON

SELECT     
manufacturer_id, 
dbo.manufacturer.name, 
email, 
website, 
contact_name,
record_status,
company_id
into #t1
FROM         dbo.manufacturer

select  manufacturer_id, phone_number, extension
into #t2
FROM         dbo.manufacturer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.manufacturer.manufacturer_id AND dbo.phone.table_name = 'Manufacturer' and dbo.phone.phone_type_id=1

select  manufacturer_id,phone_number as 'Fax'
into #t3
FROM         dbo.manufacturer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.manufacturer.manufacturer_id AND dbo.phone.table_name = 'Manufacturer' and dbo.phone.phone_type_id=5

select manufacturer_id,phone_number as 'cPhone' ,extension as 'cExtension'
into #t4
FROM         dbo.manufacturer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.manufacturer.manufacturer_id AND dbo.phone.table_name = 'Manufacturer' and dbo.phone.phone_type_id=4

select manufacturer_id,phone_number as 'cCell' 
into #t5
FROM         dbo.manufacturer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.manufacturer.manufacturer_id AND dbo.phone.table_name = 'Manufacturer' and dbo.phone.phone_type_id=2

select manufacturer_id,phone_number as 'cFax' 
into #t6
FROM         dbo.manufacturer LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.manufacturer.manufacturer_id AND dbo.phone.table_name = 'Manufacturer' and dbo.phone.phone_type_id=3

SET NOCOUNT OFF

SELECT     
#t1.manufacturer_id, 
#t1.name, 
email, 
website, 
contact_name,
record_status,
company_id,
phone_number, 
extension,
fax,
cphone,
cextension,
ccell,
cfax

from #t1 inner join #t2 on #t1.manufacturer_id = #t2.manufacturer_id
inner join #t3 on #t3.manufacturer_id = #t2.manufacturer_id
inner join #t4 on #t4.manufacturer_id = #t2.manufacturer_id
inner join #t5 on #t5.manufacturer_id = #t2.manufacturer_id
inner join #t6 on #t6.manufacturer_id = #t2.manufacturer_id

where #t1.manufacturer_id>0

drop table #t1
drop table #t2
drop table #t3
drop table #t4
drop table #t5
drop table #t6







GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO









CREATE PROCEDURE SpNotCountedItems
 
AS
SET NOCOUNT ON

declare @start_date  datetime 
declare @end_date datetime 

SELECT      top 1  @start_date  =  start_date, @end_date  =end_date
FROM         dbo.inv_audit
order by start_date desc

 
if @end_date is null
begin
	

SELECT     dbo.item.item_number, dbo.item.description AS item_description, dbo.location.description AS location_description, dbo.location.code, 
		dbo.sites.site_name, dbo.sites.description AS site_description, 
                      dbo.item.company_id, dbo.vItemTrackBy.serial_number, dbo.vItemTrackBy.date_code, dbo.vItemTrackBy.pallet, dbo.vItemTrackBy.lot, 
                      dbo.item.record_status, dbo.sites.site_id
FROM         dbo.item INNER JOIN
                      dbo.vItemTrackBy ON dbo.item.item_id = dbo.vItemTrackBy.item_id 
		 		and ( dbo.vItemTrackBy.record_status != 2 and dbo.vItemTrackBy.record_status != 3 )
INNER JOIN
                      dbo.sites INNER JOIN
                      dbo.location ON dbo.sites.site_id = dbo.location.site_id ON dbo.vItemTrackBy.location_id = dbo.location.location_id

	where  not EXISTS (	
	SELECT  * 
	
	from dbo.vAuditInfo   
	where  trans_date >= @start_date 
	and  dbo.item.item_number= dbo.vAuditInfo.item_number
	and  dbo.sites.site_name= dbo.vAuditInfo.site_name
	and  dbo.location.code= dbo.vAuditInfo.code
	and dbo.vItemTrackBy.serial_number = dbo.vAuditInfo.serial_number
	and dbo.vItemTrackBy.date_code = dbo.vAuditInfo.date_code
	and  dbo.vItemTrackBy.pallet = dbo.vAuditInfo.pallet
	and dbo.vItemTrackBy.lot = dbo.vAuditInfo.lot
	 
	)
	and dbo.item.item_type in (1, 5)
end
else
begin
SELECT     dbo.item.item_number, dbo.item.description AS item_description, dbo.location.description AS location_description, dbo.location.code, 
		dbo.sites.site_name, dbo.sites.description AS site_description,  
                      dbo.item.company_id, dbo.vItemTrackBy.serial_number, dbo.vItemTrackBy.date_code, dbo.vItemTrackBy.pallet, dbo.vItemTrackBy.lot, 
                      dbo.item.record_status, dbo.sites.site_id
FROM         dbo.item INNER JOIN
                      dbo.vItemTrackBy ON dbo.item.item_id = dbo.vItemTrackBy.item_id
				 and ( dbo.vItemTrackBy.record_status != 2 and dbo.vItemTrackBy.record_status != 3 )
INNER JOIN
                      dbo.sites INNER JOIN
                      dbo.location ON dbo.sites.site_id = dbo.location.site_id ON dbo.vItemTrackBy.location_id = dbo.location.location_id

	where  not EXISTS (	
	SELECT  * 
	
	from dbo.vAuditInfo   
	where  trans_date >= @start_date 
	and  dbo.item.item_number= dbo.vAuditInfo.item_number
	and  dbo.sites.site_name= dbo.vAuditInfo.site_name
	and  dbo.location.code= dbo.vAuditInfo.code
	and dbo.vItemTrackBy.serial_number = dbo.vAuditInfo.serial_number
	and dbo.vItemTrackBy.date_code = dbo.vAuditInfo.date_code
	and  dbo.vItemTrackBy.pallet = dbo.vAuditInfo.pallet
	and dbo.vItemTrackBy.lot = dbo.vAuditInfo.lot
	
	)
	and dbo.item.item_type in (1, 5)
end

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO




CREATE PROCEDURE SpSetupInventoryReader
 
AS
SET NOCOUNT ON
 
 
if  EXISTS (select * from dbo.sysusers where name = N'InventoryReader' and uid < 16382)
	exec sp_dropuser InventoryReader
 

if not EXISTS (select * from master.dbo.syslogins where loginname = N'InventoryReader')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'master', @loginlang = N'us_english'
	if @logindb is null or not EXISTS (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not EXISTS (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'InventoryReader', null, @logindb, @loginlang
END
 

if not EXISTS (select * from dbo.sysusers where name = N'InventoryReader' and uid < 16382)
	EXEC sp_grantdbaccess N'InventoryReader', N'InventoryReader'
 

 

exec sp_addrolemember N'db_datareader', N'InventoryReader'
 

 

exec sp_password null, null, InventoryReader
 


------------------------------------------------
--   Set Permission for InventoryReader Account to 
--   exec stored procedures 
------------------------------------------------

 

DECLARE @spname varchar(255)
DECLARE @sql varchar(255)

DECLARE SPnames CURSOR FOR
select distinct so.[Name]
from sysobjects so
where so.[Type] = 'P' and so.[Name] like 'Sp%'

OPEN SPnames

 
WHILE 1=1
begin
   	FETCH SPnames INTO @spname 
	if (@@FETCH_STATUS <> 0) break
	select @sql = 'GRANT  EXECUTE  ON [dbo].[' + @spname +']  TO [InventoryReader]'
	exec(@sql)
end

CLOSE SPnames
DEALLOCATE SPnames

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break
		
		set @output =  @output + @notetext + char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur

	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end

CLOSE id_cur
DEALLOCATE id_cur

SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO




CREATE  PROCEDURE [dbo].[SpSumNotes4Customers]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'customer'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

--//Id cursor
while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE  other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	WHILE 1= 1
	
	BEGIN
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break
	
		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	END
	CLOSE note_cur
	DEALLOCATE note_cur

	
	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end --id_cur

CLOSE id_cur
DEALLOCATE id_cur

 
SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE [SpSumNotes4Inventories]

AS
SET NOCOUNT ON

select vAddInventory.*, notes.note_date from vAddInventory 
left outer join notes on vAddInventory.transaction_id = note_id and notes.table_name = 'inventory_transactions'





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes4Items]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'item'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break

		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur

	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)

end

CLOSE id_cur
DEALLOCATE id_cur

 
SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes4Locations]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'location'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	open note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break

		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur

	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end

CLOSE id_cur
DEALLOCATE id_cur

 
SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes4Manufacturers]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'manufacturer'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break

		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur

	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end

CLOSE id_cur
DEALLOCATE id_cur

 
SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes4Sites]


AS
SET NOCOUNT ON

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'sites'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE  other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break
		
		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur

	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end

CLOSE id_cur
DEALLOCATE id_cur
 

SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO


CREATE  PROCEDURE [dbo].[SpSumNotes4Vendors]


AS
SET NOCOUNT ON	

create   table #t1 ( 
other_id int,
table_name varchar(50) null,
note_text varchar(7000) null)

DECLARE @otherid int,
@lastid int,
@lastname varchar(50),
@tablename varchar(50),
@notetext varchar(1000),
@notedate varchar(20),
@output varchar(7000),
@err int

 
select distinct other_id, table_name
into #t2
from vNotes
where table_name = 'supplier'
 
DECLARE id_cur CURSOR  FOR
SELECT other_id, table_name FROM #t2 ORDER BY other_id

open id_cur

while 1=1
begin
	FETCH id_cur INTO @lastid, @lastname
	if (@@fetch_status<>0) break
 	set @output = ''

	DECLARE note_cur CURSOR  FOR
	SELECT other_id, table_name, note_text, note_date FROM vNotes 
	WHERE  other_id = @lastid and table_name = @lastname
	ORDER BY other_id

	OPEN note_cur
	while 1=1
	begin
		FETCH note_cur INTO @otherid, @tablename, @notetext, @notedate
	 	if (@@fetch_status<>0) break

		set @output =  @output + @notetext + char(32) +  char(40) + @notedate  + char(41) + char(13)
	end
	CLOSE note_cur
	DEALLOCATE note_cur
	
	INSERT #t1 (other_id, table_name, note_text)   VALUES (@lastid, @lastname, @output)
end
CLOSE id_cur
DEALLOCATE id_cur
	 
 
SET NOCOUNT OFF

SELECT     other_id, table_name, note_text  from #t1
 

drop table #t1
drop table #t2

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO









CREATE PROCEDURE SpSupplierInfo


AS
SET NOCOUNT ON

SELECT     
supplier_id, 
supplier_number, 
name, 
email, 
website, 
contact_name, 
record_status,
company_id
into #t1
FROM         dbo.supplier
 

select  Supplier_id, phone_number, extension
into #t2
FROM         dbo.Supplier LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Supplier.Supplier_id AND dbo.phone.table_name = 'supplier' and dbo.phone.phone_type_id=1
 

select  Supplier_id,phone_number as 'Fax'
into #t3
FROM         dbo.Supplier LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Supplier.Supplier_id AND dbo.phone.table_name = 'supplier' and dbo.phone.phone_type_id=5
 

select Supplier_id,phone_number  as 'cPhone' ,extension as 'cExtension'
into #t4
FROM         dbo.Supplier LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Supplier.Supplier_id AND dbo.phone.table_name = 'supplier' and dbo.phone.phone_type_id=4
 

select Supplier_id,phone_number as 'cCell' 
into #t5
FROM         dbo.Supplier LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Supplier.Supplier_id AND dbo.phone.table_name = 'supplier' and dbo.phone.phone_type_id=2
 

select Supplier_id,phone_number as 'cFax' 
into #t6
FROM         dbo.Supplier LEFT OUTER JOIN
                      dbo.phone ON dbo.phone.phone_id = dbo.Supplier.Supplier_id AND dbo.phone.table_name = 'supplier' and dbo.phone.phone_type_id=3
 

SET NOCOUNT OFF

SELECT     
#t1.Supplier_id, 
supplier_number, 
#t1.name, 
email, 
website,
contact_name, 
record_status
company_id,
phone_number, 
extension,
fax,
cphone,
cextension,
ccell,
cfax

from #t1 inner join #t2 on #t1.Supplier_id = #t2.Supplier_id
inner join #t3 on #t3.Supplier_id = #t2.Supplier_id
inner join #t4 on #t4.Supplier_id = #t2.Supplier_id
inner join #t5 on #t5.Supplier_id = #t2.Supplier_id
inner join #t6 on #t6.Supplier_id = #t2.Supplier_id

where #t1.supplier_id>0

drop table #t1
drop table #t2
drop table #t3
drop table #t4
drop table #t5
drop table #t6




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

set ANSI_NULLS ON
set QUOTED_IDENTIFIER ON
go



-- =============================================
-- Author:		myufu
-- Create date: 04/10/2007
-- Description:	
-- =============================================
CREATE PROCEDURE [SpTransactionTempDataSet] 
@nUserID int,
@sSql varchar(1000)
AS
BEGIN
	-- If the temp table EXISTS drop it
	IF OBJECT_ID('tempdb..#transaction_temp') IS NOT NULL
	begin
	   DROP TABLE   #transaction_temp;
		print 'Table Dropped'
	end

	declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	CREATE TABLE #transaction_temp
	(
		item_number varchar(31), 
		description varchar(255), 
		site_name  varchar(30), 
		code varchar(30), 
	    other_site varchar(30),
		other_location varchar(30),
		pallet varchar(30), 
		lot  varchar(30), 
		date_code varchar(30), 
		serial_number varchar(30),
		trans_type varchar(50),
		trans_date datetime,
		quantity decimal,
		current_qty decimal,
		remaining_qty decimal,
		entry_date datetime,
		date_acquired datetime,
		due_date datetime,
		cost decimal,
		last_name varchar(110),
		record_source varchar(30),
		po varchar(38),
		customer_number_trn varchar(30),
		supplier_number_trn varchar(30),
		po_number varchar(38),
		order_number varchar(38),
		receipt_no varchar(100)
	)

	--if user has privilege on one or more site
	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			INSERT  #transaction_temp
			SELECT  item.item_number, item.description AS description, sites.site_name, location.code,
					s2.site_name, l2.code, trn.pallet, trn.lot, trn.date_code, trn.serial_number, 
					case trn.is_receive_or_ship when 'T' then case tt.trans_description_2 when 'Add' then 'Receive'
																						  when 'Remove' then 'Pick'
																						  else tt.trans_description_2
																						  end
												else tt.trans_description_2
												end as trans_description_2,
					trans_date, quantity, current_qty, remaining_qty, entry_date, 

					case trans_type when 350 then null  
					else 
						case date_acquired when '1800-01-01' then null
						else date_acquired end 
					end
						as date_acquired, 

					case trans_type when 350 then 
						case date_acquired when '1800-01-01' then null
						else date_acquired end 
					else null  end 
						as due_date, 

					trn.cost, u.first_name + ' ' + u.last_name, record_source,
					case trn.is_receive_or_ship when 'T' then ' ' else trn.po end, 
					cr.customer_number, sr.supplier_number, 
					case trn.is_receive_or_ship when 'T' then case trn.trans_type when 100 then trn.po else ' ' end else ' ' end,
					case trn.is_receive_or_ship when 'T' then case trn.trans_type when 150 then trn.po else ' ' end  else ' ' end,
					trn.receipt_no
			FROM    inventory_transactions trn INNER JOIN
					  item ON trn.item_id = item.item_id INNER JOIN
					  location ON trn.location_id = location.location_id INNER JOIN
					  sites ON location.site_id = sites.site_id and sites.site_id != 0 INNER JOIN
					  location l2 ON trn.other_id = l2.location_id INNER JOIN
					  sites s2 ON l2.site_id = s2.site_id INNER JOIN
					  transaction_types tt ON trn.trans_type = tt.trans_type_no INNER JOIN
					  users u ON trn.[user_id] = u.[user_id] INNER JOIN
					  customer cr ON trn.[customer_id] = cr.[customer_id] INNER JOIN
					  supplier sr ON trn.[supplier_id] = sr.[supplier_id]
			WHERE   item.record_status = 1 
			AND (trn.company_id = 1) 
			AND (trn.location_id IN (SELECT loc.location_id	FROM location loc))
			AND (trn.trans_type not in (200, 400) )
		end
		else	--otherwise site access restriction is applied
		begin
			INSERT  #transaction_temp
			SELECT  item.item_number, item.description AS description, sites.site_name, location.code,
					s2.site_name, l2.code, trn.pallet, trn.lot, trn.date_code, trn.serial_number, 
					case trn.is_receive_or_ship when 'T' then case tt.trans_description_2 when 'Add' then 'Receive'
																						  when 'Remove' then 'Pick'
																						  else tt.trans_description_2
																						  end
												else tt.trans_description_2
												end as trans_description_2,
					trans_date, quantity, current_qty, remaining_qty, entry_date, 
					
					case trans_type when 350 then null  
					else 
						case date_acquired when '1800-01-01' then null
						else date_acquired end 
					end
						as date_acquired, 

					case trans_type when 350 then 
						case date_acquired when '1800-01-01' then null
						else date_acquired end 
					else null  end 
						as due_date,  

					trn.cost, u.first_name + ' ' + u.last_name, record_source,
					case trn.is_receive_or_ship when 'T' then ' ' else trn.po end, 
					cr.customer_number, sr.supplier_number, 
					case trn.is_receive_or_ship when 'T' then case trn.trans_type when 100 then trn.po else ' ' end else ' ' end,
					case trn.is_receive_or_ship when 'T' then case trn.trans_type when 150 then trn.po else ' ' end  else ' ' end,
					trn.receipt_no
			FROM    inventory_transactions trn INNER JOIN
					  item ON trn.item_id = item.item_id INNER JOIN
					  location ON trn.location_id = location.location_id INNER JOIN
					  sites ON location.site_id = sites.site_id and sites.site_id != 0 INNER JOIN
					  location l2 ON trn.other_id = l2.location_id INNER JOIN
					  sites s2 ON l2.site_id = s2.site_id INNER JOIN
					  transaction_types tt ON trn.trans_type = tt.trans_type_no INNER JOIN
					  users u ON trn.[user_id] = u.[user_id] INNER JOIN
					  customer cr ON trn.[customer_id] = cr.[customer_id] INNER JOIN
					  supplier sr ON trn.[supplier_id] = sr.[supplier_id]
			WHERE   item.record_status = 1 
			AND		(trn.company_id = 1) 
			AND		(trn.location_id IN (SELECT loc.location_id	FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID)) )
			AND		(trn.trans_type not in (200, 400) )
		end
	end

	execute(@sSql);

	drop table #transaction_temp

END


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

-- =============================================
-- Author:		<myufu>
-- Create date: <06/27/2008>
-- Description:	<Get top 10 items order by trans_date from inventory transactions>
-- =============================================
CREATE PROCEDURE [SpGetTop10ItemsFromTransaction] 
	@nTransactionType int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    create table #1 ( item_id int, item_number nvarchar(31), trans_date datetime )

	insert into #1 ( item_id, item_number, trans_date )
	select item.item_id, item.item_number, inventory_transactions.trans_date 
	from item, inventory_transactions 
	where item.item_id = inventory_transactions.item_id 
	and inventory_transactions.trans_type = @nTransactionType 
	and item.record_status = 1 and item.company_id = 1 
	order by inventory_transactions.trans_date desc

	SET NOCOUNT ON
	
	select distinct top 10 item_id, item_number from #1

	drop table #1
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [SpSumNotes4InventoriesAdjust]

AS
SET NOCOUNT ON

select vAdjustInventory.*, notes.note_text, notes.note_date from vAdjustInventory 
left outer join notes on vAdjustInventory.transaction_id = note_id and notes.table_name = 'inventory_transactions'




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [SpSumNotes4InventoriesCheckInOut]

AS
SET NOCOUNT ON

select vCheckOutInfo.*, notes.note_text, notes.note_date from vCheckOutInfo 
left outer join notes on vCheckOutInfo.transaction_id = note_id and notes.table_name = 'inventory_transactions'



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE PROCEDURE [SpSumNotes4InventoriesMove]

AS
SET NOCOUNT ON

SELECT vMoveFrom.*, vMoveTo.*, notes.note_text, notes.note_date  from vMoveFrom 
left outer join vMoveTo on vMoveFrom.Transaction_id = vMoveTo.transaction_id
left outer join notes on vMoveFrom.transaction_id = note_id and notes.table_name = 'inventory_transactions'


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [SpSumNotes4Audits]

AS
SET NOCOUNT ON

select vAuditInfo.*, notes.note_text, notes.note_date from vAuditInfo 
left outer join notes on vAuditInfo.transaction_id = note_id and notes.table_name = 'audit_transactions'



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO


CREATE PROCEDURE [SpSumNotes4CheckOut]

AS
SET NOCOUNT ON

select vCheckOutInfo.*, notes.note_text, notes.note_date from vCheckOutInfo 
left outer join notes on vCheckOutInfo.transaction_id = note_id and notes.table_name = 'inventory_transactions'

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Mary Fu
-- Create date: 12/11/2008
-- Description:	Retrieve transactions record
-- =============================================
CREATE PROCEDURE [SpTransactionHistory] @nUserID int
AS

BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			SELECT  trn.transaction_id, item.item_number, item.description AS item_description, trans_date, trans_type,
			case trn.is_receive_or_ship when 'T' then case tt.trans_description when 'Add' then 'Receive'
																				when 'Remove' then 'Pick'
																				else tt.trans_description end
										else case trn.trans_type when 450 then case trn.adjust_type 
																				when 'a' then tt.trans_description_2 + ' By Count'
																				else tt.trans_description_2 + ' By Difference' 
																			 end  
																else tt.trans_description_2 end
				 end as trans_description,
			quantity, current_qty, remaining_qty, trn.record_source, entry_date,
			case trans_type when 350 then null  
			else 
				case date_acquired when '1800-01-01' then null
				else date_acquired end 
			end 
				as date_acquired, 
			trn.cost, trn.pallet, trn.lot, trn.date_code, trn.serial_number,
			trn.company_id, location.description AS location_description, location.code, sites.description AS site_description,
			sites.site_name, trn.is_receive_or_ship, trn.receipt_no, sites.site_id, item.item_type, 
			s2.description AS moveto_site_description, l2.description AS moveto_location_description,
			l2.code AS moveto_location, s2.site_name AS moveto_site_name,
			case trans_type when 350 then 
				case date_acquired when '1800-01-01' then null
				else date_acquired end 
			else null  end 
				as due_date, 
			trn.user_id, u.first_name + ' ' + u.last_name as user_name,
			dbo.notes.note_text, dbo.notes.note_date
			FROM    inventory_transactions trn INNER JOIN
					  item ON trn.item_id = item.item_id INNER JOIN
					  location ON trn.location_id = location.location_id INNER JOIN
					  sites ON location.site_id = sites.site_id and sites.site_id != 0 INNER JOIN
					  location l2 ON trn.other_id = l2.location_id INNER JOIN
					  sites s2 ON l2.site_id = s2.site_id INNER JOIN
					  transaction_types tt ON trn.trans_type = tt.trans_type_no INNER JOIN
					  users u ON trn.[user_id] = u.[user_id] LEFT OUTER JOIN
					  dbo.notes ON trn.transaction_id = dbo.notes.note_id AND dbo.notes.table_name = 'inventory_transactions'


			WHERE   (item.record_status = 1) AND (item.item_type <> 2)
			AND (trn.company_id = 1) 
			AND (trn.location_id IN (SELECT loc.location_id	FROM location loc))
			AND (trn.trans_type not in (200, 400))
		    AND (trn.record_status >= 1)
			ORDER BY trn.trans_date, trn.entry_date
		end
		else	--otherwise site access restriction is applied
		begin
			SELECT  trn.transaction_id, item.item_number, item.description AS item_description, trans_date, trans_type,
			case trn.is_receive_or_ship when 'T' then 
			case tt.trans_description when 'Add' then 'Receive'
										when 'Remove' then 'Pick'
										else tt.trans_description end
			else tt.trans_description
			end 
				as trans_description,
			quantity, current_qty, remaining_qty, trn.record_source, entry_date,
			case trans_type when 350 then null  
			else 
				case date_acquired when '1800-01-01' then null
				else date_acquired end 
			end 
				as date_acquired, 
			trn.cost, trn.pallet, trn.lot, trn.date_code, trn.serial_number,
			trn.company_id, location.description AS location_description, location.code, sites.description AS site_description,
			sites.site_name, trn.is_receive_or_ship, trn.receipt_no, sites.site_id, item.item_type, 
			s2.description AS moveto_site_description, l2.description AS moveto_location_description,
			l2.code AS moveto_location, s2.site_name AS moveto_site_name,
			case trans_type when 350 then 
				case date_acquired when '1800-01-01' then null
				else date_acquired end 
			else null  end 
				as due_date, 
			trn.user_id, u.first_name + ' ' + u.last_name as user_name,
			dbo.notes.note_text, dbo.notes.note_date
			FROM    inventory_transactions trn INNER JOIN
					  item ON trn.item_id = item.item_id INNER JOIN
					  location ON trn.location_id = location.location_id INNER JOIN
					  sites ON location.site_id = sites.site_id and sites.site_id != 0 INNER JOIN
					  location l2 ON trn.other_id = l2.location_id INNER JOIN
					  sites s2 ON l2.site_id = s2.site_id INNER JOIN
					  transaction_types tt ON trn.trans_type = tt.trans_type_no INNER JOIN
					  users u ON trn.[user_id] = u.[user_id] LEFT OUTER JOIN
					  dbo.notes ON trn.transaction_id = dbo.notes.note_id AND dbo.notes.table_name = 'inventory_transactions'
			WHERE   (item.record_status = 1) AND (item.item_type <> 2)
			AND (trn.company_id = 1) 
			AND (trn.location_id IN (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID)))
			AND (trn.trans_type not in (200, 400))
		    AND (trn.record_status >= 1)
			ORDER BY trn.trans_date, trn.entry_date
		end
	end
END

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Mary Fu
-- Create date: 12/10/2008
-- Description:	Retrieve move from transactions record
-- =============================================
CREATE PROCEDURE [SpMoveTransactions] @nUserID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			SELECT dbo.inventory_transactions.transaction_id, dbo.item.item_number, dbo.item.description AS item_description, 
								  dbo.location.description AS location_description, dbo.inventory_transactions.trans_date, dbo.inventory_transactions.date_acquired, 
								  dbo.inventory_transactions.quantity, dbo.inventory_transactions.serial_number, dbo.inventory_transactions.date_code, 
								  dbo.inventory_transactions.pallet, dbo.inventory_transactions.lot, dbo.location.code, dbo.inventory_transactions.company_id, 
								  dbo.sites.description AS site_description, dbo.inventory_transactions.trans_type, dbo.supplier.name AS supplier_name, 
								  dbo.inventory_transactions.action_type, dbo.inventory_transactions.entry_date, dbo.inventory_transactions.current_qty, 
								  dbo.inventory_transactions.remaining_qty, dbo.inventory_transactions.cost, dbo.inventory_transactions.record_status, 
								  dbo.inventory_transactions.record_source, dbo.inventory_transactions.user_id, dbo.users.last_name, dbo.users.first_name, 
								  dbo.customer.name AS customer_name, dbo.customer.customer_number, dbo.sites.site_name, dbo.inventory_transactions.line_item_id, 
								  dbo.inventory_transactions.po, dbo.inventory_transactions.is_receive_or_ship, dbo.sites.site_id, dbo.inventory_transactions.other_transaction_id, 
								  dbo.item.item_type, dbo.inventory_transactions.adjust_trans_code, dbo.transaction_types.trans_description,
								  dbo.notes.note_text, dbo.notes.note_date, site2.description AS moveto_site_description, loc2.description AS moveto_location_description,
								  loc2.code AS moveto_location, site2.site_name AS moveto_site_name
			FROM  dbo.inventory_transactions 
			inner join dbo.item ON dbo.inventory_transactions.item_id = dbo.item.item_id and dbo.item.record_status = 1
			inner join dbo.location ON dbo.inventory_transactions.location_id = dbo.location.location_id 
			inner join dbo.sites ON dbo.location.site_id = dbo.sites.site_id 
			inner join dbo.supplier ON dbo.inventory_transactions.supplier_id = dbo.supplier.supplier_id 
			inner join dbo.users ON dbo.inventory_transactions.user_id = dbo.users.user_id 
			inner join dbo.customer ON dbo.inventory_transactions.customer_id = dbo.customer.customer_id 
			inner join dbo.transaction_types ON dbo.inventory_transactions.trans_type = dbo.transaction_types.trans_type_no 
			inner join location loc2 on loc2.location_id = dbo.inventory_transactions.other_id
			inner join sites site2 on loc2.site_id = site2.site_id
			left outer join notes on dbo.inventory_transactions.transaction_id = note_id and notes.table_name = 'inventory_transactions'
			WHERE ( inventory_transactions.record_status = 1 or inventory_transactions.record_status = 2 )
			and inventory_transactions.trans_type = 250
		end
		else	--otherwise site access restriction is applied
		begin
			SELECT dbo.inventory_transactions.transaction_id, dbo.item.item_number, dbo.item.description AS item_description, 
								  dbo.location.description AS location_description, dbo.inventory_transactions.trans_date, dbo.inventory_transactions.date_acquired, 
								  dbo.inventory_transactions.quantity, dbo.inventory_transactions.serial_number, dbo.inventory_transactions.date_code, 
								  dbo.inventory_transactions.pallet, dbo.inventory_transactions.lot, dbo.location.code, dbo.inventory_transactions.company_id, 
								  dbo.sites.description AS site_description, dbo.inventory_transactions.trans_type, dbo.supplier.name AS supplier_name, 
								  dbo.inventory_transactions.action_type, dbo.inventory_transactions.entry_date, dbo.inventory_transactions.current_qty, 
								  dbo.inventory_transactions.remaining_qty, dbo.inventory_transactions.cost, dbo.inventory_transactions.record_status, 
								  dbo.inventory_transactions.record_source, dbo.inventory_transactions.user_id, dbo.users.last_name, dbo.users.first_name, 
								  dbo.customer.name AS customer_name, dbo.customer.customer_number, dbo.sites.site_name, dbo.inventory_transactions.line_item_id, 
								  dbo.inventory_transactions.po, dbo.inventory_transactions.is_receive_or_ship, dbo.sites.site_id, dbo.inventory_transactions.other_transaction_id, 
								  dbo.item.item_type, dbo.inventory_transactions.adjust_trans_code, dbo.transaction_types.trans_description,
								  dbo.notes.note_text, dbo.notes.note_date, site2.description AS moveto_site_description, loc2.description AS moveto_location_description,
								  loc2.code AS moveto_location, site2.site_name AS moveto_site_name
			FROM  dbo.inventory_transactions 
			inner join dbo.item ON dbo.inventory_transactions.item_id = dbo.item.item_id and dbo.item.record_status = 1
			inner join dbo.location ON dbo.inventory_transactions.location_id = dbo.location.location_id 
			inner join dbo.sites ON dbo.location.site_id = dbo.sites.site_id 
			inner join dbo.supplier ON dbo.inventory_transactions.supplier_id = dbo.supplier.supplier_id 
			inner join dbo.users ON dbo.inventory_transactions.user_id = dbo.users.user_id 
			inner join dbo.customer ON dbo.inventory_transactions.customer_id = dbo.customer.customer_id 
			inner join dbo.transaction_types ON dbo.inventory_transactions.trans_type = dbo.transaction_types.trans_type_no 
			inner join location loc2 on loc2.location_id = dbo.inventory_transactions.other_id
			inner join sites site2 on loc2.site_id = site2.site_id
			left outer join notes on dbo.inventory_transactions.transaction_id = note_id and notes.table_name = 'inventory_transactions'
			WHERE ( inventory_transactions.record_status = 1 or inventory_transactions.record_status = 2 )
			and inventory_transactions.trans_type = 250
			and inventory_transactions.location_id IN (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID))
		end
	end
END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Mary Fu
-- Create date: 01/20/2009
-- Description:	Retrieve customer transactions records
-- =============================================
CREATE PROCEDURE [SpCustomerTransactionHistory] 
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT    dbo.item.item_number, dbo.item.description AS item_des, dbo.supplier.supplier_number, dbo.supplier.name AS supplier_name, 
			  dbo.inventory_transactions.trans_type, dbo.inventory_transactions.action_type, dbo.inventory_transactions.entry_date, 
			  dbo.inventory_transactions.trans_date, dbo.inventory_transactions.date_acquired, dbo.inventory_transactions.adjust_type, 
			  dbo.inventory_transactions.quantity, dbo.inventory_transactions.current_qty, dbo.inventory_transactions.remaining_qty, 
			  convert (money , dbo.inventory_transactions.cost) as cost, dbo.inventory_transactions.serial_number, dbo.inventory_transactions.date_code, dbo.inventory_transactions.po, 
			  dbo.inventory_transactions.lot, dbo.inventory_transactions.pallet, dbo.inventory_transactions.adjust_trans_code, 
			  dbo.inventory_transactions.record_status, dbo.inventory_transactions.record_source, dbo.inventory_transactions.company_id, dbo.users.last_name, 
			  dbo.users.first_name, dbo.customer.customer_number, dbo.customer.name AS customer_name, dbo.item.avgcost, 
			  dbo.inventory_transactions.is_receive_or_ship, dbo.inventory_transactions.receipt_no, dbo.sites.site_id, 
			  dbo.item.item_type, dbo.inventory_transactions.transaction_id, dbo.inventory_transactions.other_transaction_id,
			case dbo.inventory_transactions.is_receive_or_ship when 'T' then 
			case dbo.transaction_types.trans_description when 'Add' then 'Receive'
										when 'Remove' then 'Pick'
										else dbo.transaction_types.trans_description end
			else dbo.transaction_types.trans_description
			end as trans_description
	FROM      dbo.inventory_transactions INNER JOIN
			  dbo.item ON dbo.inventory_transactions.item_id = dbo.item.item_id INNER JOIN
			  dbo.supplier ON dbo.inventory_transactions.supplier_id = dbo.supplier.supplier_id INNER JOIN
			  dbo.users ON dbo.inventory_transactions.user_id = dbo.users.user_id INNER JOIN
			  dbo.customer ON dbo.inventory_transactions.customer_id = dbo.customer.customer_id INNER JOIN
			  dbo.location ON dbo.inventory_transactions.location_id = dbo.location.location_id INNER JOIN
			  dbo.sites ON dbo.location.site_id = dbo.sites.site_id INNER JOIN
			  dbo.transaction_types ON dbo.inventory_transactions.trans_type = dbo.transaction_types.trans_type_no
	WHERE     (dbo.item.item_type <> 2)
	and		  dbo.inventory_transactions.trans_type in ( 100, 150, 350, 300 )
    -- exclude assembly items transactions that are related to disassembly
    and       dbo.inventory_transactions.transaction_id not in ( select trans.transaction_id from inventory_transactions trans
															     inner join dbo.item ON trans.item_id = item.item_id and item_type = 5
																 where trans.trans_type = 150
																 and trans.transaction_id in ( select distinct other_transaction_id from inventory_transactions where other_transaction_id != 0) )

END
GO



SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		Christina Ye
-- Create date: 6/23/2009
-- Modify date: 8/28/2009
-- Description:	Retrieve move from transactions record with cost info
-- =============================================
CREATE PROCEDURE [SpMoveTransactionsWithCost] @nUserID int
AS
BEGIN
	
--UPDATE inventory_transactions SET cost = null where trans_type = 250

	IF OBJECT_ID(N'tempdb..#t1', N'U') IS NOT NULL 
	BEGIN
		PRINT 'Drop temp table #t1';
		DROP TABLE #t1;
	END;

	PRINT 'Create temp table #t1';
	---------------------------------------------
	CREATE TABLE #t1(
		[transaction_id] [int] NOT NULL,
		[item_number] [varchar](31) NULL,
		[item_description] [varchar](255) NULL,
		[location_description] [varchar](255) NULL,
		[trans_date] [datetime] NULL,
		[date_acquired] [datetime] NULL,
		[quantity] [decimal](18, 4) NULL,
		[serial_number] [varchar](25) NULL,
		[date_code] [varchar](25) NULL,
		[pallet] [varchar](25) NULL,
		[lot] [varchar](25) NULL,
		[code] [varchar](30) NOT NULL,
		[company_id] [int] NULL,
		[site_description] [varchar](255) NULL,
		[trans_type] [int] NOT NULL,
		[supplier_name] [varchar](50) NULL,
		[action_type] [int] NULL,
		[entry_date] [datetime] NULL,
		[current_qty] [decimal](18, 4) NULL,
		[remaining_qty] [decimal](18, 4) NULL,
		[cost] [decimal](18, 4) NULL,
		[record_status] [smallint] NOT NULL,
		[record_source] [varchar](30) NULL,
		[user_id] [int] NULL,
		[last_name] [varchar](50) NULL,
		[first_name] [varchar](50) NULL,
		[customer_name] [varchar](100) NULL,
		[customer_number] [varchar](30) NOT NULL,
		[site_name] [varchar](50) NOT NULL,
		[line_item_id] [int] NULL,
		[po] [varchar](38) NULL,
		[is_receive_or_ship] [char](1) NOT NULL,
		[site_id] [int] NOT NULL,
		[other_transaction_id] [int] NULL,
		[item_type] [int] NOT NULL,
		[adjust_trans_code] [varchar](25) NULL,
		[trans_description] [varchar](50) NULL,
		[note_text] [varchar](1000) NULL,
		[note_date] [datetime] NULL,
		[moveto_site_description] [varchar](255) NULL,
		[moveto_location_description] [varchar](255) NULL,
		[moveto_location] [varchar](30) NOT NULL,
		[moveto_site_name] [varchar](50) NOT NULL
	) ON [PRIMARY]


	INSERT INTO #t1
	SELECT     inventory_transactions.transaction_id, item.item_number, item.description AS item_description, location.description AS location_description, 
                      inventory_transactions.trans_date, inventory_transactions.date_acquired, inventory_transactions.quantity, inventory_transactions.serial_number, 
                      inventory_transactions.date_code, inventory_transactions.pallet, inventory_transactions.lot, location.code, inventory_transactions.company_id, 
                      sites.description AS site_description, inventory_transactions.trans_type, supplier.name AS supplier_name, inventory_transactions.action_type, 
                      inventory_transactions.entry_date, inventory_transactions.quantity, inventory_transactions.remaining_qty, inventory_transactions.cost, 
                      inventory_transactions.record_status, inventory_transactions.record_source, inventory_transactions.user_id, users.last_name, users.first_name, 
                      customer.name AS customer_name, customer.customer_number, sites.site_name, inventory_transactions.line_item_id, inventory_transactions.po, 
                      inventory_transactions.is_receive_or_ship, sites.site_id, inventory_transactions.other_transaction_id, item.item_type, 
                      inventory_transactions.adjust_trans_code, transaction_types.trans_description, notes.note_text, notes.note_date, 
                      site2.description AS moveto_site_description, loc2.description AS moveto_location_description, loc2.code AS moveto_location, 
                      site2.site_name AS moveto_site_name
			FROM         inventory_transactions 
			INNER JOIN
                      item ON inventory_transactions.item_id = item.item_id AND item.record_status = 1 INNER JOIN
                      location ON inventory_transactions.location_id = location.location_id INNER JOIN
                      sites ON location.site_id = sites.site_id INNER JOIN
                      supplier ON inventory_transactions.supplier_id = supplier.supplier_id INNER JOIN
                      users ON inventory_transactions.user_id = users.user_id INNER JOIN
                      customer ON inventory_transactions.customer_id = customer.customer_id INNER JOIN
                      transaction_types ON inventory_transactions.trans_type = transaction_types.trans_type_no INNER JOIN
                      location AS loc2 ON loc2.location_id = inventory_transactions.other_id INNER JOIN
                      sites AS site2 ON loc2.site_id = site2.site_id LEFT OUTER JOIN
                      notes ON inventory_transactions.transaction_id = notes.note_id AND notes.table_name = 'inventory_transactions'
			WHERE     (inventory_transactions.record_status = 1 OR
                      inventory_transactions.record_status = 2) AND (inventory_transactions.trans_type in (250, 200))

	DECLARE @tranx_id int, @item_no varchar(31), @qty decimal(18, 4), 
			@sn nvarchar(25), @datecode nvarchar(25), @pallet nvarchar(25), @lot nvarchar(25), 
			@supplier nvarchar(30), @user_id int, 
			@to_site nvarchar(50), @to_loc nvarchar(30),
			@tranx_id2 int, @cost decimal(18, 4)
	DECLARE @remaining_qty decimal(18, 4), @total_cost decimal(18, 4), @200_qty decimal(18, 4), @avg_cost decimal(18, 4)
	DECLARE @ok_update int

	DECLARE cur_250 CURSOR FOR 
		SELECT transaction_id, item_number, quantity, serial_number, date_code, pallet, lot, supplier_name, user_id, cost,
			   moveto_site_name, moveto_location FROM #t1 WHERE trans_type = 250

	OPEN cur_250

	FETCH NEXT FROM cur_250 INTO @tranx_id, @item_no, @qty, @sn, @datecode, @pallet, @lot, @supplier, @user_id, @cost,
			   @to_site, @to_loc

	WHILE @@FETCH_STATUS = 0
	BEGIN
	   
		SET @ok_update = 0;

		IF (@cost is null) 
		BEGIN
			print 'Out: id='+CAST(@tranx_id AS nvarchar(100))+', item='+@item_no+', qty='+CAST(@qty AS nvarchar(15))+', '+@sn+', '+@datecode+', '+@pallet+', '+@lot+', '+@supplier+', '+CAST(@user_id AS nvarchar(15))+', '+@to_site+', '+@to_loc

			SET @remaining_qty = @qty
			SET @total_cost = 0

			DECLARE cur_200 CURSOR FOR 
				SELECT transaction_id, cost, quantity FROM #t1 
				WHERE trans_type = 200 
					  AND transaction_id > @tranx_id AND item_number = @item_no AND quantity <= @qty 
					  AND serial_number = @sn AND date_code = @datecode AND pallet = @pallet AND lot = @lot 
					  AND supplier_name = @supplier AND user_id = @user_id 
					  AND site_name = @to_site and code = @to_loc 
					  and current_qty > 0
				ORDER BY transaction_id

			OPEN cur_200
			FETCH NEXT FROM cur_200 INTO @tranx_id2, @cost, @200_qty

			WHILE @@FETCH_STATUS = 0
			BEGIN
				print '  Mathing In: '+CAST(@tranx_id2 AS nvarchar(100))+', qty='+CAST(@200_qty AS nvarchar(100))+', cost='+CAST(@cost AS nvarchar(100))

				IF @remaining_qty <= @200_qty 
				BEGIN
					SET @total_cost = @total_cost + @remaining_qty * @cost
					UPDATE #t1 SET current_qty = current_qty - @remaining_qty WHERE transaction_id=@tranx_id2 
					SET @remaining_qty = 0
				END
				ELSE
				BEGIN
					SET @total_cost = @total_cost + @200_qty *@cost
					SET @remaining_qty = @remaining_qty - @200_qty
					UPDATE #t1 SET current_qty = 0 WHERE transaction_id=@tranx_id2 
				END

				IF @remaining_qty = 0
				BEGIN 
					PRINT '..done with this 250'
					SET @ok_update = 1;
					BREAK
				END

				FETCH NEXT FROM cur_200 INTO @tranx_id2, @cost, @200_qty
			END
			
			if (@ok_update = 1)
			BEGIN
				SET @avg_cost = @total_cost/@qty
				PRINT '  avg_cost = '+CAST(@total_cost AS nvarchar(100))+' / '++CAST(@qty AS nvarchar(100))+' = '+CAST(@avg_cost AS nvarchar(100))

				--UPDATE #t1 SET cost = @avg_cost WHERE transaction_id=@tranx_id
				UPDATE inventory_transactions SET cost = @avg_cost WHERE transaction_id=@tranx_id
			END

			CLOSE cur_200
			DEALLOCATE cur_200

		   END
		ELSE
			print 'already got cost'

		FETCH NEXT FROM cur_250 INTO @tranx_id, @item_no, @qty, @sn, @datecode, @pallet, @lot, @supplier, @user_id, @cost, 
			   @to_site, @to_loc
     
	END

	CLOSE cur_250
	DEALLOCATE cur_250


	DROP TABLE #t1


	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    declare @nNumberOfSite int
	set @nNumberOfSite = 0

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	if( @nNumberOfSite > 0 )
	begin
		declare @nSiteID int
		set @nSiteID = 0

		-- if user has privilege on only one site, check to see if site_id is 0
		if( @nNumberOfSite = 1 )
		begin
			select @nSiteID = site_id from user_site where user_id = @nUserID
		end
		
		-- if site id is 0, user @nUserID can access to all sites
		if( @nSiteID = 0 )
		begin
			SELECT dbo.inventory_transactions.transaction_id, dbo.item.item_number, dbo.item.description AS item_description, 
								  dbo.location.description AS location_description, dbo.inventory_transactions.trans_date, dbo.inventory_transactions.date_acquired, 
								  dbo.inventory_transactions.quantity, dbo.inventory_transactions.serial_number, dbo.inventory_transactions.date_code, 
								  dbo.inventory_transactions.pallet, dbo.inventory_transactions.lot, dbo.location.code, dbo.inventory_transactions.company_id, 
								  dbo.sites.description AS site_description, dbo.inventory_transactions.trans_type, dbo.supplier.name AS supplier_name, 
								  dbo.inventory_transactions.action_type, dbo.inventory_transactions.entry_date, dbo.inventory_transactions.current_qty, 
								  dbo.inventory_transactions.remaining_qty, dbo.inventory_transactions.cost, dbo.inventory_transactions.record_status, 
								  dbo.inventory_transactions.record_source, dbo.inventory_transactions.user_id, dbo.users.last_name, dbo.users.first_name, 
								  dbo.customer.name AS customer_name, dbo.customer.customer_number, dbo.sites.site_name, dbo.inventory_transactions.line_item_id, 
								  dbo.inventory_transactions.po, dbo.inventory_transactions.is_receive_or_ship, dbo.sites.site_id, dbo.inventory_transactions.other_transaction_id, 
								  dbo.item.item_type, dbo.inventory_transactions.adjust_trans_code, dbo.transaction_types.trans_description,
								  dbo.notes.note_text, dbo.notes.note_date, site2.description AS moveto_site_description, loc2.description AS moveto_location_description,
								  loc2.code AS moveto_location, site2.site_name AS moveto_site_name
			FROM  dbo.inventory_transactions 
			inner join dbo.item ON dbo.inventory_transactions.item_id = dbo.item.item_id and dbo.item.record_status = 1
			inner join dbo.location ON dbo.inventory_transactions.location_id = dbo.location.location_id 
			inner join dbo.sites ON dbo.location.site_id = dbo.sites.site_id 
			inner join dbo.supplier ON dbo.inventory_transactions.supplier_id = dbo.supplier.supplier_id 
			inner join dbo.users ON dbo.inventory_transactions.user_id = dbo.users.user_id 
			inner join dbo.customer ON dbo.inventory_transactions.customer_id = dbo.customer.customer_id 
			inner join dbo.transaction_types ON dbo.inventory_transactions.trans_type = dbo.transaction_types.trans_type_no 
			inner join location loc2 on loc2.location_id = dbo.inventory_transactions.other_id
			inner join sites site2 on loc2.site_id = site2.site_id
			left outer join notes on dbo.inventory_transactions.transaction_id = note_id and notes.table_name = 'inventory_transactions'
			WHERE ( inventory_transactions.record_status = 1 or inventory_transactions.record_status = 2 )
			and inventory_transactions.trans_type = 250
		end
		else	--otherwise site access restriction is applied
		begin
			SELECT dbo.inventory_transactions.transaction_id, dbo.item.item_number, dbo.item.description AS item_description, 
								  dbo.location.description AS location_description, dbo.inventory_transactions.trans_date, dbo.inventory_transactions.date_acquired, 
								  dbo.inventory_transactions.quantity, dbo.inventory_transactions.serial_number, dbo.inventory_transactions.date_code, 
								  dbo.inventory_transactions.pallet, dbo.inventory_transactions.lot, dbo.location.code, dbo.inventory_transactions.company_id, 
								  dbo.sites.description AS site_description, dbo.inventory_transactions.trans_type, dbo.supplier.name AS supplier_name, 
								  dbo.inventory_transactions.action_type, dbo.inventory_transactions.entry_date, dbo.inventory_transactions.current_qty, 
								  dbo.inventory_transactions.remaining_qty, dbo.inventory_transactions.cost, dbo.inventory_transactions.record_status, 
								  dbo.inventory_transactions.record_source, dbo.inventory_transactions.user_id, dbo.users.last_name, dbo.users.first_name, 
								  dbo.customer.name AS customer_name, dbo.customer.customer_number, dbo.sites.site_name, dbo.inventory_transactions.line_item_id, 
								  dbo.inventory_transactions.po, dbo.inventory_transactions.is_receive_or_ship, dbo.sites.site_id, dbo.inventory_transactions.other_transaction_id, 
								  dbo.item.item_type, dbo.inventory_transactions.adjust_trans_code, dbo.transaction_types.trans_description,
								  dbo.notes.note_text, dbo.notes.note_date, site2.description AS moveto_site_description, loc2.description AS moveto_location_description,
								  loc2.code AS moveto_location, site2.site_name AS moveto_site_name
			FROM  dbo.inventory_transactions 
			inner join dbo.item ON dbo.inventory_transactions.item_id = dbo.item.item_id and dbo.item.record_status = 1
			inner join dbo.location ON dbo.inventory_transactions.location_id = dbo.location.location_id 
			inner join dbo.sites ON dbo.location.site_id = dbo.sites.site_id 
			inner join dbo.supplier ON dbo.inventory_transactions.supplier_id = dbo.supplier.supplier_id 
			inner join dbo.users ON dbo.inventory_transactions.user_id = dbo.users.user_id 
			inner join dbo.customer ON dbo.inventory_transactions.customer_id = dbo.customer.customer_id 
			inner join dbo.transaction_types ON dbo.inventory_transactions.trans_type = dbo.transaction_types.trans_type_no 
			inner join location loc2 on loc2.location_id = dbo.inventory_transactions.other_id
			inner join sites site2 on loc2.site_id = site2.site_id
			left outer join notes on dbo.inventory_transactions.transaction_id = note_id and notes.table_name = 'inventory_transactions'
			WHERE ( inventory_transactions.record_status = 1 or inventory_transactions.record_status = 2 )
			and inventory_transactions.trans_type = 250
			and inventory_transactions.location_id IN (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID))
		end
	end
END
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SpItemSummaryReport] 
@nUserID int

AS

BEGIN
	
-- SET NOCOUNT ON added to prevent extra result sets from
	
-- interfering with SELECT statements.
	

SET NOCOUNT ON;

    

declare @nNumberOfSite int
	
set @nNumberOfSite = 0

	

select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	

if( @nNumberOfSite > 0 )
	
begin
		
declare @nSiteID int
		
set @nSiteID = 0

		

-- if user has privilege on only one site, check to see if site_id is 0
		
if( @nNumberOfSite = 1 )
		
begin
			
	select @nSiteID = site_id from user_site where user_id = @nUserID
		
end
		
		

-- if site id is 0, user @nUserID can access to all sites
		
if( @nSiteID = 0 )
		
begin

	SELECT     dbo.item.item_number, dbo.item.description, dbo.item.cost, dbo.item.avgcost, dbo.category.description AS catagory, dbo.manufacturer.name AS manufacturer, dbo.supplier.name AS supplier, dbo.item.min_stock_level, dbo.item.reorder_qty, 
dbo.item.record_status AS item_status, dbo.item.company_id, dbo.inventory.quantity, dbo.inventory.record_status AS inventory_status, dbo.location.code, dbo.sites.description AS site_description, dbo.location.description AS location_description, dbo.sites.site_name, 
 dbo.item.item_id, dbo.sites.site_id

	FROM      dbo.location INNER JOIN

	dbo.inventory ON dbo.location.location_id = dbo.inventory.location_id INNER JOIN

	dbo.sites ON dbo.location.site_id = dbo.sites.site_id RIGHT OUTER JOIN

	dbo.item INNER JOIN
	dbo.category ON dbo.item.category_id = dbo.category.category_id INNER JOIN

	dbo.manufacturer ON dbo.item.manufacturer_id = dbo.manufacturer.manufacturer_id INNER JOIN

	dbo.supplier ON dbo.item.supplier_id = dbo.supplier.supplier_id ON dbo.inventory.item_id = dbo.item.item_id

	WHERE dbo.item.record_status = 1

	AND dbo.inventory.quantity <> 0

	AND dbo.sites.site_id <> 0
		
end

else	--otherwise site access restriction is applied
		
begin
			
	SELECT     dbo.item.item_number, dbo.item.description, dbo.item.cost, dbo.item.avgcost, dbo.category.description AS catagory, dbo.manufacturer.name AS manufacturer, dbo.supplier.name AS supplier, dbo.item.min_stock_level, dbo.item.reorder_qty, 
dbo.item.record_status AS item_status, dbo.item.company_id, dbo.inventory.quantity, dbo.inventory.record_status AS inventory_status, dbo.location.code, dbo.sites.description AS site_description, dbo.location.description AS location_description, dbo.sites.site_name, 
 dbo.item.item_id, dbo.sites.site_id

	FROM      dbo.location INNER JOIN

	dbo.inventory ON dbo.location.location_id = dbo.inventory.location_id INNER JOIN

	dbo.sites ON dbo.location.site_id = dbo.sites.site_id RIGHT OUTER JOIN

	dbo.item INNER JOIN
	dbo.category ON dbo.item.category_id = dbo.category.category_id INNER JOIN

	dbo.manufacturer ON dbo.item.manufacturer_id = dbo.manufacturer.manufacturer_id INNER JOIN

	dbo.supplier ON dbo.item.supplier_id = dbo.supplier.supplier_id ON dbo.inventory.item_id = dbo.item.item_id

	WHERE dbo.item.record_status = 1

	AND dbo.inventory.quantity <> 0

	AND dbo.sites.site_id <> 0
	
	AND dbo.inventory.location_id IN (SELECT loc.location_id FROM location loc where loc.site_id in (select site_id from user_site where user_id = @nUserID))
		
end
	
end

END

GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [SpSitesLocations] 
@nUserID int

AS

BEGIN
	
	-- SET NOCOUNT ON added to prevent extra result sets from
	
	-- interfering with SELECT statements.
	
	SET NOCOUNT ON;

    

	declare @nNumberOfSite int
	
	set @nNumberOfSite = 0

	

	select @nNumberOfSite = count(*) from user_site where user_id = @nUserID

	

	if( @nNumberOfSite > 0 )
	
	begin
		
		declare @nSiteID int
		
		set @nSiteID = 0

		

		-- if user has privilege on only one site, check to see if site_id is 0
		
		if( @nNumberOfSite = 1 )
		
		begin
			
			select @nSiteID = site_id from user_site where user_id = @nUserID
		
		end
		
		

		-- if site id is 0, user @nUserID can access to all sites
		
		if( @nSiteID = 0 )
		
		begin
			
			SELECT sites.site_id, sites.site_name, sites.description as site_description, loc.location_id, loc.code, loc.description as loc_description, loc.company_id
			
			FROM dbo.location loc 
			
			INNER JOIN dbo.sites ON loc.site_id = dbo.sites.site_id
			
			WHERE loc.record_status = 1
			
			AND sites.record_status = 1
			
			AND loc.location_id <> 0
		
		end
		
		else
		
		begin
			
			SELECT sites.site_id, sites.site_name, sites.description as site_description, loc.location_id, loc.code, loc.description as loc_description, loc.company_id
			
			FROM dbo.location loc 
			
			INNER JOIN dbo.sites ON loc.site_id = dbo.sites.site_id
			
			WHERE loc.record_status = 1
			
			AND dbo.sites.record_status = 1
			
			AND loc.location_id <> 0
			
			AND loc.location_id IN (SELECT location_id FROM location where site_id in (select site_id from user_site where user_id = @nUserID))
		
		end
	
	end

END	
GO



SET ANSI_NULLS OFF
GO

SET QUOTED_IDENTIFIER OFF
GO


CREATE PROCEDURE [SpMoveItemCostRecords]
(@pItemId as int)
AS
begin transaction

	INSERT INTO dbo.item_cost_history
	SELECT *,GETDATE() FROM item_cost WHERE item_id = @pItemId
	
	DELETE FROM item_cost  WHERE item_id = @pItemId
	
commit transaction

GO

------------------------------------
--TEST Stored Procedure to fix some issues with FIFO
------------------------------------
CREATE PROCEDURE [dbo].[SpFixZeroCost]
AS
SET NOCOUNT ON

DECLARE @itemId int,
@siteId int,
@addDate DateTime,
@unitCost decimal(18,4),
@quantity decimal(18,4),
@avgCost decimal(21,7),
@totalQuantity decimal(18,4),
@totalValue decimal(18,4),
@lastUpdated DateTime

DECLARE itemCostCur cursor for
select item_cost.item_id, site_id, add_date, unit_cost, quantity, avg_cost, total_quantity, total_value, last_updated from item_cost INNER JOIN
item ON item_cost.item_id = item.item_id where site_id <> 0 and item.cost_calc_method = 2
open itemCostCur

while 1=1
begin
	FETCH itemCostCur INTO @itemId, @siteId, @addDate, @unitCost, @quantity, @avgCost, @totalQuantity, @totalValue, @lastUpdated
	if(@@FETCH_STATUS<>0) break	
	
	if((select count(unit_cost) from item_cost where item_id = @itemId and site_id = 0 and DATEADD(ms, -DATEPART(ms, add_date), add_date) = DATEADD(ms, -DATEPART(ms, @addDate), @addDate)) = 1)
	BEGIN
		print '------------------------'
		DECLARE @PrintString nvarchar(30)
		SET @PrintString = RTRIM(CAST((select count(unit_cost) from item_cost where item_id = @itemId and site_id = 0 and DATEADD(ms, -DATEPART(ms, add_date), add_date) = DATEADD(ms, -DATEPART(ms, @addDate), @addDate)) AS nvarchar(30)))
		print RTRIM(CAST(@itemId AS nvarchar(30))) + ': ' + @PrintString
		print RTRIM(CAST(DATEADD(ms, -DATEPART(ms, @addDate), @addDate) as nvarchar(30)))
		print '------------------------'
		print ''
		if((select unit_cost from item_cost where item_id = @itemId and site_id = 0 and DATEADD(ms, -DATEPART(ms, add_date), add_date) = DATEADD(ms, -DATEPART(ms, @addDate), @addDate)) <> @unitCost)
		BEGIN
			UPDATE item_cost set unit_cost = @unitCost where item_id = @itemId and site_id = 0 and DATEADD(ms, -DATEPART(ms, add_date), add_date) = DATEADD(ms, -DATEPART(ms, @addDate), @addDate)
		END
	END
	
--	if((select count(item_id) from item_cost 
--	where item_id = @itemId and site_id = 0 and 
--	DATEADD(ms, -DATEPART(ms, add_date), add_date) = DATEADD(ms, -DATEPART(ms, @addDate), @addDate) and 
--	unit_cost = @unitCost) = 0)
--	BEGIN
--		INSERT INTO item_cost (item_id, site_id, add_date, unit_cost, quantity, avg_cost, total_quantity, total_value, last_updated)
--		VALUES (@itemId, 0, @addDate, @unitCost, @quantity, @avgCost, @totalQuantity, @totalValue, @lastUpdated)
--	END
	
END
CLOSE itemCostCur
DEALLOCATE itemCostCur